using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Threading;
using System.Data.Odbc;
using System.Net;
using System.Net.Sockets;

namespace AnalogOutputContinuousMode
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class F_Main : System.Windows.Forms.Form
    {
		private System.Windows.Forms.GroupBox GB_Help;
		private System.Windows.Forms.Label L_Help;
		private System.Windows.Forms.GroupBox GB_Description;
		private System.Windows.Forms.Label L_Description;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox TB_IPAddress_3;
		private System.Windows.Forms.TextBox TB_IPAddress_2;
		private System.Windows.Forms.TextBox TB_IPAddress_1;
		private System.Windows.Forms.TextBox TB_IPAddress_0;
		private System.Windows.Forms.Label label19;
        private System.Windows.Forms.GroupBox GB_Channel;
		private System.Windows.Forms.Button B_Connect;
		private System.Windows.Forms.ComboBox CB_Channel;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.ComboBox CB_OutputType;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.ComboBox CB_Polarity;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.ComboBox CB_TriggerGate;
        private System.Windows.Forms.Label label7;
        private GroupBox GB_Action;
        private Label label10;
        private ComboBox CB_TriggerAction;
        private GroupBox GB_SamplingRate;
        private Label label8;
        private Label label9;
        private ComboBox CB_SamplingRate;
        private TextBox TB_Prescaller;
        private GroupBox GB_StopState;
        private Label label11;
        private Label label13;
        private ComboBox CB_StopMode0;
        private ComboBox CB_StopMode1;
        private GroupBox GB_Datas;
        private Label label17;
        private TextBox TB_FixedTimeStep;
        private Button B_Start;
        private Button B_Stop;
        private Button B_LoadSCV;
        private OpenFileDialog CSVOpenDialog;
        private DataGridView DGW_Datas;
        private TextBox textBox1;
        private Label label12;
        private TextBox TB_MinValue;
        private Label label14;
        private ComboBox CB_Source;
		private System.ComponentModel.IContainer components;

		public F_Main()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(F_Main));
            this.GB_Help = new System.Windows.Forms.GroupBox();
            this.L_Help = new System.Windows.Forms.Label();
            this.GB_Description = new System.Windows.Forms.GroupBox();
            this.L_Description = new System.Windows.Forms.Label();
            this.B_Connect = new System.Windows.Forms.Button();
            this.label3 = new System.Windows.Forms.Label();
            this.label1 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.TB_IPAddress_3 = new System.Windows.Forms.TextBox();
            this.TB_IPAddress_2 = new System.Windows.Forms.TextBox();
            this.TB_IPAddress_1 = new System.Windows.Forms.TextBox();
            this.TB_IPAddress_0 = new System.Windows.Forms.TextBox();
            this.label19 = new System.Windows.Forms.Label();
            this.GB_Channel = new System.Windows.Forms.GroupBox();
            this.label6 = new System.Windows.Forms.Label();
            this.CB_Polarity = new System.Windows.Forms.ComboBox();
            this.label5 = new System.Windows.Forms.Label();
            this.CB_OutputType = new System.Windows.Forms.ComboBox();
            this.label4 = new System.Windows.Forms.Label();
            this.CB_Channel = new System.Windows.Forms.ComboBox();
            this.label7 = new System.Windows.Forms.Label();
            this.CB_TriggerGate = new System.Windows.Forms.ComboBox();
            this.GB_Action = new System.Windows.Forms.GroupBox();
            this.label10 = new System.Windows.Forms.Label();
            this.CB_TriggerAction = new System.Windows.Forms.ComboBox();
            this.GB_SamplingRate = new System.Windows.Forms.GroupBox();
            this.label8 = new System.Windows.Forms.Label();
            this.label9 = new System.Windows.Forms.Label();
            this.CB_SamplingRate = new System.Windows.Forms.ComboBox();
            this.TB_Prescaller = new System.Windows.Forms.TextBox();
            this.GB_StopState = new System.Windows.Forms.GroupBox();
            this.label11 = new System.Windows.Forms.Label();
            this.label13 = new System.Windows.Forms.Label();
            this.CB_StopMode1 = new System.Windows.Forms.ComboBox();
            this.CB_StopMode0 = new System.Windows.Forms.ComboBox();
            this.GB_Datas = new System.Windows.Forms.GroupBox();
            this.TB_MinValue = new System.Windows.Forms.TextBox();
            this.label14 = new System.Windows.Forms.Label();
            this.textBox1 = new System.Windows.Forms.TextBox();
            this.CB_Source = new System.Windows.Forms.ComboBox();
            this.B_LoadSCV = new System.Windows.Forms.Button();
            this.DGW_Datas = new System.Windows.Forms.DataGridView();
            this.label17 = new System.Windows.Forms.Label();
            this.TB_FixedTimeStep = new System.Windows.Forms.TextBox();
            this.label12 = new System.Windows.Forms.Label();
            this.B_Start = new System.Windows.Forms.Button();
            this.B_Stop = new System.Windows.Forms.Button();
            this.CSVOpenDialog = new System.Windows.Forms.OpenFileDialog();
            this.GB_Help.SuspendLayout();
            this.GB_Description.SuspendLayout();
            this.GB_Channel.SuspendLayout();
            this.GB_Action.SuspendLayout();
            this.GB_SamplingRate.SuspendLayout();
            this.GB_StopState.SuspendLayout();
            this.GB_Datas.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.DGW_Datas)).BeginInit();
            this.SuspendLayout();
            // 
            // GB_Help
            // 
            this.GB_Help.Controls.Add(this.L_Help);
            this.GB_Help.Location = new System.Drawing.Point(16, 88);
            this.GB_Help.Name = "GB_Help";
            this.GB_Help.Size = new System.Drawing.Size(621, 56);
            this.GB_Help.TabIndex = 44;
            this.GB_Help.TabStop = false;
            this.GB_Help.Text = "Help";
            // 
            // L_Help
            // 
            this.L_Help.Location = new System.Drawing.Point(8, 16);
            this.L_Help.Name = "L_Help";
            this.L_Help.Size = new System.Drawing.Size(594, 32);
            this.L_Help.TabIndex = 0;
            this.L_Help.Text = "You must first enter the IP address of the MSX-E351x system, then click on the bu" +
                "tton \"Connect\".";
            // 
            // GB_Description
            // 
            this.GB_Description.Controls.Add(this.L_Description);
            this.GB_Description.Location = new System.Drawing.Point(16, 16);
            this.GB_Description.Name = "GB_Description";
            this.GB_Description.Size = new System.Drawing.Size(621, 64);
            this.GB_Description.TabIndex = 43;
            this.GB_Description.TabStop = false;
            this.GB_Description.Text = "Description";
            // 
            // L_Description
            // 
            this.L_Description.Location = new System.Drawing.Point(8, 16);
            this.L_Description.Name = "L_Description";
            this.L_Description.Size = new System.Drawing.Size(598, 30);
            this.L_Description.TabIndex = 0;
            this.L_Description.Text = resources.GetString("L_Description.Text");
            // 
            // B_Connect
            // 
            this.B_Connect.Location = new System.Drawing.Point(447, 150);
            this.B_Connect.Name = "B_Connect";
            this.B_Connect.Size = new System.Drawing.Size(171, 32);
            this.B_Connect.TabIndex = 40;
            this.B_Connect.Text = "Connect";
            this.B_Connect.Click += new System.EventHandler(this.B_Connect_Click);
            // 
            // label3
            // 
            this.label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label3.Location = new System.Drawing.Point(384, 157);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(8, 16);
            this.label3.TabIndex = 39;
            this.label3.Text = "-";
            // 
            // label1
            // 
            this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label1.Location = new System.Drawing.Point(328, 157);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(8, 16);
            this.label1.TabIndex = 38;
            this.label1.Text = "-";
            // 
            // label2
            // 
            this.label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label2.Location = new System.Drawing.Point(272, 157);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(8, 16);
            this.label2.TabIndex = 37;
            this.label2.Text = "-";
            // 
            // TB_IPAddress_3
            // 
            this.TB_IPAddress_3.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.TB_IPAddress_3.Location = new System.Drawing.Point(400, 157);
            this.TB_IPAddress_3.MaxLength = 3;
            this.TB_IPAddress_3.Name = "TB_IPAddress_3";
            this.TB_IPAddress_3.Size = new System.Drawing.Size(32, 20);
            this.TB_IPAddress_3.TabIndex = 36;
            this.TB_IPAddress_3.Enter += new System.EventHandler(this.TB_IPAddress_3_Enter);
            // 
            // TB_IPAddress_2
            // 
            this.TB_IPAddress_2.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.TB_IPAddress_2.Location = new System.Drawing.Point(344, 157);
            this.TB_IPAddress_2.MaxLength = 3;
            this.TB_IPAddress_2.Name = "TB_IPAddress_2";
            this.TB_IPAddress_2.Size = new System.Drawing.Size(32, 20);
            this.TB_IPAddress_2.TabIndex = 35;
            this.TB_IPAddress_2.Enter += new System.EventHandler(this.TB_IPAddress_2_Enter);
            // 
            // TB_IPAddress_1
            // 
            this.TB_IPAddress_1.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.TB_IPAddress_1.Location = new System.Drawing.Point(288, 157);
            this.TB_IPAddress_1.MaxLength = 3;
            this.TB_IPAddress_1.Name = "TB_IPAddress_1";
            this.TB_IPAddress_1.Size = new System.Drawing.Size(32, 20);
            this.TB_IPAddress_1.TabIndex = 34;
            this.TB_IPAddress_1.Enter += new System.EventHandler(this.TB_IPAddress_1_Enter);
            // 
            // TB_IPAddress_0
            // 
            this.TB_IPAddress_0.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.TB_IPAddress_0.ImeMode = System.Windows.Forms.ImeMode.Disable;
            this.TB_IPAddress_0.Location = new System.Drawing.Point(232, 157);
            this.TB_IPAddress_0.MaxLength = 3;
            this.TB_IPAddress_0.Name = "TB_IPAddress_0";
            this.TB_IPAddress_0.Size = new System.Drawing.Size(32, 20);
            this.TB_IPAddress_0.TabIndex = 33;
            this.TB_IPAddress_0.Enter += new System.EventHandler(this.TB_IPAddress_0_Enter);
            // 
            // label19
            // 
            this.label19.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label19.Location = new System.Drawing.Point(18, 157);
            this.label19.Name = "label19";
            this.label19.Size = new System.Drawing.Size(208, 16);
            this.label19.TabIndex = 32;
            this.label19.Text = "IP address of the MSX-E351x system :";
            // 
            // GB_Channel
            // 
            this.GB_Channel.Controls.Add(this.label6);
            this.GB_Channel.Controls.Add(this.CB_Polarity);
            this.GB_Channel.Controls.Add(this.label5);
            this.GB_Channel.Controls.Add(this.CB_OutputType);
            this.GB_Channel.Controls.Add(this.label4);
            this.GB_Channel.Controls.Add(this.CB_Channel);
            this.GB_Channel.Enabled = false;
            this.GB_Channel.Location = new System.Drawing.Point(16, 188);
            this.GB_Channel.Name = "GB_Channel";
            this.GB_Channel.Size = new System.Drawing.Size(264, 108);
            this.GB_Channel.TabIndex = 46;
            this.GB_Channel.TabStop = false;
            this.GB_Channel.Text = "Channel configuration";
            // 
            // label6
            // 
            this.label6.AutoSize = true;
            this.label6.Location = new System.Drawing.Point(6, 76);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(47, 13);
            this.label6.TabIndex = 5;
            this.label6.Text = "Polarity :";
            // 
            // CB_Polarity
            // 
            this.CB_Polarity.Items.AddRange(new object[] {
            "Unipolar",
            "Bipolar"});
            this.CB_Polarity.Location = new System.Drawing.Point(96, 73);
            this.CB_Polarity.Name = "CB_Polarity";
            this.CB_Polarity.Size = new System.Drawing.Size(78, 21);
            this.CB_Polarity.TabIndex = 4;
            this.CB_Polarity.Text = "Unipolar";
            // 
            // label5
            // 
            this.label5.AutoSize = true;
            this.label5.Location = new System.Drawing.Point(6, 51);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(68, 13);
            this.label5.TabIndex = 3;
            this.label5.Text = "Output type :";
            // 
            // CB_OutputType
            // 
            this.CB_OutputType.Items.AddRange(new object[] {
            "Voltage",
            "Current"});
            this.CB_OutputType.Location = new System.Drawing.Point(96, 46);
            this.CB_OutputType.Name = "CB_OutputType";
            this.CB_OutputType.Size = new System.Drawing.Size(78, 21);
            this.CB_OutputType.TabIndex = 2;
            this.CB_OutputType.Text = "Voltage";
            this.CB_OutputType.SelectedIndexChanged += new System.EventHandler(this.CB_OutputType_SelectedIndexChanged);
            // 
            // label4
            // 
            this.label4.AutoSize = true;
            this.label4.Location = new System.Drawing.Point(6, 24);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(55, 13);
            this.label4.TabIndex = 1;
            this.label4.Text = "Channel : ";
            // 
            // CB_Channel
            // 
            this.CB_Channel.Items.AddRange(new object[] {
            "0",
            "1",
            "2",
            "3",
            "4",
            "5",
            "6",
            "7"});
            this.CB_Channel.Location = new System.Drawing.Point(96, 19);
            this.CB_Channel.Name = "CB_Channel";
            this.CB_Channel.Size = new System.Drawing.Size(78, 21);
            this.CB_Channel.TabIndex = 0;
            this.CB_Channel.Text = "0";
            // 
            // label7
            // 
            this.label7.AutoSize = true;
            this.label7.Location = new System.Drawing.Point(8, 22);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(133, 13);
            this.label7.TabIndex = 7;
            this.label7.Text = "Extern gate/trigger source:";
            // 
            // CB_TriggerGate
            // 
            this.CB_TriggerGate.Items.AddRange(new object[] {
            "Disabled",
            "Hardware trigger",
            "Synchro trigger (one shot)"});
            this.CB_TriggerGate.Location = new System.Drawing.Point(167, 19);
            this.CB_TriggerGate.Name = "CB_TriggerGate";
            this.CB_TriggerGate.Size = new System.Drawing.Size(163, 21);
            this.CB_TriggerGate.TabIndex = 6;
            this.CB_TriggerGate.Text = "Disabled";
            this.CB_TriggerGate.SelectedIndexChanged += new System.EventHandler(this.CB_TriggerGate_SelectedIndexChanged);
            // 
            // GB_Action
            // 
            this.GB_Action.Controls.Add(this.label10);
            this.GB_Action.Controls.Add(this.label7);
            this.GB_Action.Controls.Add(this.CB_TriggerAction);
            this.GB_Action.Controls.Add(this.CB_TriggerGate);
            this.GB_Action.Enabled = false;
            this.GB_Action.Location = new System.Drawing.Point(288, 188);
            this.GB_Action.Name = "GB_Action";
            this.GB_Action.Size = new System.Drawing.Size(349, 108);
            this.GB_Action.TabIndex = 46;
            this.GB_Action.TabStop = false;
            this.GB_Action.Text = "Extern gate/trigger configuration";
            // 
            // label10
            // 
            this.label10.AutoSize = true;
            this.label10.Location = new System.Drawing.Point(8, 49);
            this.label10.Name = "label10";
            this.label10.Size = new System.Drawing.Size(152, 13);
            this.label10.TabIndex = 7;
            this.label10.Text = "Hardware trigger input acction:";
            // 
            // CB_TriggerAction
            // 
            this.CB_TriggerAction.Enabled = false;
            this.CB_TriggerAction.Items.AddRange(new object[] {
            "Rising front trigger (one shot)",
            "Falling front trigger (one shot)",
            "Both front trigger (one shot)",
            "High level gate",
            "Low level gate"});
            this.CB_TriggerAction.Location = new System.Drawing.Point(166, 46);
            this.CB_TriggerAction.Name = "CB_TriggerAction";
            this.CB_TriggerAction.Size = new System.Drawing.Size(164, 21);
            this.CB_TriggerAction.TabIndex = 6;
            this.CB_TriggerAction.Text = "Rising front trigger (one shot)";
            // 
            // GB_SamplingRate
            // 
            this.GB_SamplingRate.Controls.Add(this.label8);
            this.GB_SamplingRate.Controls.Add(this.label9);
            this.GB_SamplingRate.Controls.Add(this.CB_SamplingRate);
            this.GB_SamplingRate.Controls.Add(this.TB_Prescaller);
            this.GB_SamplingRate.Enabled = false;
            this.GB_SamplingRate.Location = new System.Drawing.Point(288, 302);
            this.GB_SamplingRate.Name = "GB_SamplingRate";
            this.GB_SamplingRate.Size = new System.Drawing.Size(349, 83);
            this.GB_SamplingRate.TabIndex = 46;
            this.GB_SamplingRate.TabStop = false;
            this.GB_SamplingRate.Text = "Sampling rate";
            // 
            // label8
            // 
            this.label8.AutoSize = true;
            this.label8.Location = new System.Drawing.Point(8, 52);
            this.label8.Name = "label8";
            this.label8.Size = new System.Drawing.Size(59, 13);
            this.label8.TabIndex = 7;
            this.label8.Text = "Prescaller :";
            // 
            // label9
            // 
            this.label9.AutoSize = true;
            this.label9.Location = new System.Drawing.Point(8, 22);
            this.label9.Name = "label9";
            this.label9.Size = new System.Drawing.Size(112, 13);
            this.label9.TabIndex = 7;
            this.label9.Text = "Sampling rate source :";
            // 
            // CB_SamplingRate
            // 
            this.CB_SamplingRate.Items.AddRange(new object[] {
            "20 kHz",
            "40 kHz",
            "Synchro trigger",
            "High hardware trigger input edge",
            "Low hardware trigger input edge",
            "High/low hardware trigger input edge"});
            this.CB_SamplingRate.Location = new System.Drawing.Point(126, 19);
            this.CB_SamplingRate.Name = "CB_SamplingRate";
            this.CB_SamplingRate.Size = new System.Drawing.Size(204, 21);
            this.CB_SamplingRate.TabIndex = 6;
            this.CB_SamplingRate.Text = "20 kHz";
            this.CB_SamplingRate.SelectedIndexChanged += new System.EventHandler(this.CB_SamplingRate_SelectedIndexChanged);
            // 
            // TB_Prescaller
            // 
            this.TB_Prescaller.Enabled = false;
            this.TB_Prescaller.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.TB_Prescaller.ImeMode = System.Windows.Forms.ImeMode.Disable;
            this.TB_Prescaller.Location = new System.Drawing.Point(126, 49);
            this.TB_Prescaller.MaxLength = 20;
            this.TB_Prescaller.Name = "TB_Prescaller";
            this.TB_Prescaller.Size = new System.Drawing.Size(204, 20);
            this.TB_Prescaller.TabIndex = 33;
            this.TB_Prescaller.Text = "0";
            this.TB_Prescaller.Enter += new System.EventHandler(this.TB_IPAddress_0_Enter);
            // 
            // GB_StopState
            // 
            this.GB_StopState.Controls.Add(this.label11);
            this.GB_StopState.Controls.Add(this.label13);
            this.GB_StopState.Controls.Add(this.CB_StopMode1);
            this.GB_StopState.Controls.Add(this.CB_StopMode0);
            this.GB_StopState.Enabled = false;
            this.GB_StopState.Location = new System.Drawing.Point(16, 302);
            this.GB_StopState.Name = "GB_StopState";
            this.GB_StopState.Size = new System.Drawing.Size(264, 83);
            this.GB_StopState.TabIndex = 46;
            this.GB_StopState.TabStop = false;
            this.GB_StopState.Text = "Stop state";
            // 
            // label11
            // 
            this.label11.AutoSize = true;
            this.label11.Location = new System.Drawing.Point(8, 49);
            this.label11.Name = "label11";
            this.label11.Size = new System.Drawing.Size(188, 13);
            this.label11.TabIndex = 5;
            this.label11.Text = "Set to 0V/0mA after a stop command :";
            // 
            // label13
            // 
            this.label13.AutoSize = true;
            this.label13.Location = new System.Drawing.Point(8, 22);
            this.label13.Name = "label13";
            this.label13.Size = new System.Drawing.Size(179, 13);
            this.label13.TabIndex = 1;
            this.label13.Text = "Set to 0V/0mA after write all values :";
            // 
            // CB_StopMode1
            // 
            this.CB_StopMode1.Items.AddRange(new object[] {
            "No",
            "Yes"});
            this.CB_StopMode1.Location = new System.Drawing.Point(201, 46);
            this.CB_StopMode1.Name = "CB_StopMode1";
            this.CB_StopMode1.Size = new System.Drawing.Size(47, 21);
            this.CB_StopMode1.TabIndex = 0;
            this.CB_StopMode1.Text = "No";
            // 
            // CB_StopMode0
            // 
            this.CB_StopMode0.Items.AddRange(new object[] {
            "No",
            "Yes"});
            this.CB_StopMode0.Location = new System.Drawing.Point(201, 19);
            this.CB_StopMode0.Name = "CB_StopMode0";
            this.CB_StopMode0.Size = new System.Drawing.Size(47, 21);
            this.CB_StopMode0.TabIndex = 0;
            this.CB_StopMode0.Text = "No";
            // 
            // GB_Datas
            // 
            this.GB_Datas.Controls.Add(this.TB_MinValue);
            this.GB_Datas.Controls.Add(this.label14);
            this.GB_Datas.Controls.Add(this.textBox1);
            this.GB_Datas.Controls.Add(this.CB_Source);
            this.GB_Datas.Controls.Add(this.B_LoadSCV);
            this.GB_Datas.Controls.Add(this.DGW_Datas);
            this.GB_Datas.Controls.Add(this.label17);
            this.GB_Datas.Controls.Add(this.TB_FixedTimeStep);
            this.GB_Datas.Controls.Add(this.label12);
            this.GB_Datas.Enabled = false;
            this.GB_Datas.Location = new System.Drawing.Point(16, 391);
            this.GB_Datas.Name = "GB_Datas";
            this.GB_Datas.Size = new System.Drawing.Size(621, 229);
            this.GB_Datas.TabIndex = 46;
            this.GB_Datas.TabStop = false;
            this.GB_Datas.Text = "Output values";
            // 
            // TB_MinValue
            // 
            this.TB_MinValue.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.TB_MinValue.ImeMode = System.Windows.Forms.ImeMode.Disable;
            this.TB_MinValue.Location = new System.Drawing.Point(201, 45);
            this.TB_MinValue.MaxLength = 20;
            this.TB_MinValue.Name = "TB_MinValue";
            this.TB_MinValue.Size = new System.Drawing.Size(99, 20);
            this.TB_MinValue.TabIndex = 33;
            this.TB_MinValue.Text = "1";
            // 
            // label14
            // 
            this.label14.AutoSize = true;
            this.label14.Location = new System.Drawing.Point(12, 77);
            this.label14.Name = "label14";
            this.label14.Size = new System.Drawing.Size(116, 13);
            this.label14.TabIndex = 5;
            this.label14.Text = "Data source selection :";
            // 
            // textBox1
            // 
            this.textBox1.BorderStyle = System.Windows.Forms.BorderStyle.None;
            this.textBox1.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.textBox1.Location = new System.Drawing.Point(15, 106);
            this.textBox1.Multiline = true;
            this.textBox1.Name = "textBox1";
            this.textBox1.ReadOnly = true;
            this.textBox1.Size = new System.Drawing.Size(289, 39);
            this.textBox1.TabIndex = 49;
            this.textBox1.Text = "You have the possibility to load a CSV file or to fill the table manually";
            // 
            // CB_Source
            // 
            this.CB_Source.Items.AddRange(new object[] {
            "SOAP",
            "Data receiver"});
            this.CB_Source.Location = new System.Drawing.Point(201, 74);
            this.CB_Source.Name = "CB_Source";
            this.CB_Source.Size = new System.Drawing.Size(99, 21);
            this.CB_Source.TabIndex = 0;
            this.CB_Source.Text = "SOAP";
            // 
            // B_LoadSCV
            // 
            this.B_LoadSCV.Location = new System.Drawing.Point(11, 151);
            this.B_LoadSCV.Name = "B_LoadSCV";
            this.B_LoadSCV.Size = new System.Drawing.Size(289, 29);
            this.B_LoadSCV.TabIndex = 47;
            this.B_LoadSCV.Text = "Load CSV file";
            this.B_LoadSCV.UseVisualStyleBackColor = true;
            this.B_LoadSCV.Click += new System.EventHandler(this.B_LoadSCV_Click);
            // 
            // DGW_Datas
            // 
            this.DGW_Datas.AllowUserToResizeRows = false;
            this.DGW_Datas.BackgroundColor = System.Drawing.Color.White;
            this.DGW_Datas.ColumnHeadersHeightSizeMode = System.Windows.Forms.DataGridViewColumnHeadersHeightSizeMode.DisableResizing;
            this.DGW_Datas.Location = new System.Drawing.Point(315, 19);
            this.DGW_Datas.Name = "DGW_Datas";
            this.DGW_Datas.RowHeadersBorderStyle = System.Windows.Forms.DataGridViewHeaderBorderStyle.Single;
            this.DGW_Datas.RowHeadersWidthSizeMode = System.Windows.Forms.DataGridViewRowHeadersWidthSizeMode.DisableResizing;
            this.DGW_Datas.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
            this.DGW_Datas.ShowCellErrors = false;
            this.DGW_Datas.ShowCellToolTips = false;
            this.DGW_Datas.Size = new System.Drawing.Size(287, 204);
            this.DGW_Datas.TabIndex = 48;
            this.DGW_Datas.CellValidating += new System.Windows.Forms.DataGridViewCellValidatingEventHandler(this.DGW_Datas_CellValidating);
            this.DGW_Datas.CellEndEdit += new System.Windows.Forms.DataGridViewCellEventHandler(this.DGW_Datas_CellEndEdit);
            this.DGW_Datas.DataError += new System.Windows.Forms.DataGridViewDataErrorEventHandler(this.DGW_Datas_DataError);
            // 
            // label17
            // 
            this.label17.AutoSize = true;
            this.label17.Location = new System.Drawing.Point(12, 22);
            this.label17.Name = "label17";
            this.label17.Size = new System.Drawing.Size(83, 13);
            this.label17.TabIndex = 5;
            this.label17.Text = "Fixed time step :";
            // 
            // TB_FixedTimeStep
            // 
            this.TB_FixedTimeStep.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.TB_FixedTimeStep.ImeMode = System.Windows.Forms.ImeMode.Disable;
            this.TB_FixedTimeStep.Location = new System.Drawing.Point(201, 19);
            this.TB_FixedTimeStep.MaxLength = 20;
            this.TB_FixedTimeStep.Name = "TB_FixedTimeStep";
            this.TB_FixedTimeStep.Size = new System.Drawing.Size(99, 20);
            this.TB_FixedTimeStep.TabIndex = 33;
            this.TB_FixedTimeStep.Text = "0";
            this.TB_FixedTimeStep.TextChanged += new System.EventHandler(this.TB_FixedTimeStep_TextChanged);
            // 
            // label12
            // 
            this.label12.AutoSize = true;
            this.label12.Location = new System.Drawing.Point(12, 48);
            this.label12.Name = "label12";
            this.label12.Size = new System.Drawing.Size(188, 13);
            this.label12.TabIndex = 5;
            this.label12.Text = "Number of analgue value before start :";
            // 
            // B_Start
            // 
            this.B_Start.Enabled = false;
            this.B_Start.Location = new System.Drawing.Point(27, 626);
            this.B_Start.Name = "B_Start";
            this.B_Start.Size = new System.Drawing.Size(289, 32);
            this.B_Start.TabIndex = 40;
            this.B_Start.Text = "Start the sample";
            this.B_Start.Click += new System.EventHandler(this.B_Start_Click);
            // 
            // B_Stop
            // 
            this.B_Stop.Enabled = false;
            this.B_Stop.Location = new System.Drawing.Point(329, 626);
            this.B_Stop.Name = "B_Stop";
            this.B_Stop.Size = new System.Drawing.Size(289, 32);
            this.B_Stop.TabIndex = 40;
            this.B_Stop.Text = "Stop the sample";
            this.B_Stop.Click += new System.EventHandler(this.B_Stop_Click);
            // 
            // CSVOpenDialog
            // 
            this.CSVOpenDialog.DefaultExt = "txt csv";
            this.CSVOpenDialog.FileName = "*.csv";
            this.CSVOpenDialog.Filter = "CSV files (*.csv)|*.csv|Text files (*.txt)|*.txt";
            // 
            // F_Main
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(659, 680);
            this.Controls.Add(this.GB_SamplingRate);
            this.Controls.Add(this.GB_Action);
            this.Controls.Add(this.GB_Datas);
            this.Controls.Add(this.GB_StopState);
            this.Controls.Add(this.GB_Channel);
            this.Controls.Add(this.GB_Help);
            this.Controls.Add(this.B_Start);
            this.Controls.Add(this.GB_Description);
            this.Controls.Add(this.B_Stop);
            this.Controls.Add(this.B_Connect);
            this.Controls.Add(this.label3);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.TB_IPAddress_3);
            this.Controls.Add(this.TB_IPAddress_2);
            this.Controls.Add(this.TB_IPAddress_1);
            this.Controls.Add(this.TB_IPAddress_0);
            this.Controls.Add(this.label19);
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.Name = "F_Main";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "C# MSX-E351x : Analog output access generator, continuous mode";
            this.Load += new System.EventHandler(this.F_AnalogOutputContinuousMode_Load);
            this.Closed += new System.EventHandler(this.F_AnalogOutputContinuousMode_Closed);
            this.FormClosing += new System.Windows.Forms.FormClosingEventHandler(this.F_Main_FormClosing);
            this.GB_Help.ResumeLayout(false);
            this.GB_Description.ResumeLayout(false);
            this.GB_Channel.ResumeLayout(false);
            this.GB_Channel.PerformLayout();
            this.GB_Action.ResumeLayout(false);
            this.GB_Action.PerformLayout();
            this.GB_SamplingRate.ResumeLayout(false);
            this.GB_SamplingRate.PerformLayout();
            this.GB_StopState.ResumeLayout(false);
            this.GB_StopState.PerformLayout();
            this.GB_Datas.ResumeLayout(false);
            this.GB_Datas.PerformLayout();
            ((System.ComponentModel.ISupportInitialize)(this.DGW_Datas)).EndInit();
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new F_Main());
		}

		// Global Variable
		MXCommon_WebReference.MXCommon MX_Common;
		MSXE351x_WebReference.MSXE351x MSXE351x;
		MSXE351x_WebReference.DefaultResponse Response;
        byte[]   bValues = null;
        ushort[] uValues = null;
        ulong[] ulValues = null;
        Thread ClientThread = null;
        ulong ulChannel = 0;
        bool boExitWrite = false;
        Socket SocketClient = null;
        delegate void StopCallback(object sender, EventArgs e);


		private void F_AnalogOutputContinuousMode_Load(object sender, System.EventArgs e)
		{
            DataTable Datas = new DataTable();

            MX_Common = new MXCommon_WebReference.MXCommon();
			MSXE351x = new MSXE351x_WebReference.MSXE351x();
			MX_Common.Timeout = 2000;
			MSXE351x.Timeout = 2000;

            Datas.Columns.Add("Time step", typeof(int));
            Datas.Columns.Add("Analog value", typeof(int));
            DGW_Datas.DataSource = Datas;
            DGW_Datas.Columns[0].Width = (DGW_Datas.Width / 2) - 30;
            DGW_Datas.Columns[1].Width = (DGW_Datas.Width / 2) - 30;
        }

		private void F_AnalogOutputContinuousMode_Closed(object sender, System.EventArgs e)
		{
			if (MSXE351x != null)
				MSXE351x = null;
			if (MX_Common != null)
				MX_Common = null;

			System.GC.Collect();
		
		}

        private void CB_OutputType_SelectedIndexChanged(object sender, EventArgs e)
        {
            CB_Polarity.Enabled = (CB_OutputType.SelectedIndex == 0);
        }

        private void CB_TriggerGate_SelectedIndexChanged(object sender, EventArgs e)
        {
            CB_TriggerAction.Enabled = (CB_TriggerGate.SelectedIndex == 1);
        }

        private void CB_SamplingRate_SelectedIndexChanged(object sender, EventArgs e)
        {
            TB_Prescaller.Enabled = (CB_SamplingRate.SelectedIndex > 1);
        }


        private void TB_IPAddress_0_Enter(object sender, System.EventArgs e)
        {
            TB_IPAddress_0.SelectAll();
        }

        private void TB_IPAddress_1_Enter(object sender, System.EventArgs e)
        {
            TB_IPAddress_1.SelectAll();
        }

        private void TB_IPAddress_2_Enter(object sender, System.EventArgs e)
        {
            TB_IPAddress_2.SelectAll();
        }

        private void TB_IPAddress_3_Enter(object sender, System.EventArgs e)
        {
            TB_IPAddress_3.SelectAll();
        }

        private void TestValue(Object sObject, String Value, out Int32 iValue)
        {
            try
            {
                iValue = Convert.ToInt32(Value);
            }
            catch
            {
                iValue = 0;
                MessageBox.Show("Value format error", this.Text);
                if (sObject != null)
                {
                    if (sObject.GetType() != typeof(DataGridViewTextBoxCell))
                    {
                        ((TextBox)sObject).Focus();
                    }
                    else
                    {
                        DataGridViewTextBoxCell Cell = (DataGridViewTextBoxCell)sObject;
                        Cell.DataGridView.FirstDisplayedScrollingRowIndex = Cell.RowIndex;
                        Cell.DataGridView.FirstDisplayedScrollingColumnIndex = Cell.ColumnIndex;
                        Cell.DataGridView.Refresh();
                        Cell.DataGridView.CurrentCell = Cell.DataGridView.Rows[Cell.RowIndex].Cells[Cell.ColumnIndex];
                    }
                }
                throw new System.ApplicationException();
            }
        }

        private void TestValue(Object sObject, String Value, Int32 Min, Int32 Max, out Int32 iValue)
        {
            try
            {
                TestValue(sObject, Value, out iValue);

                if ((iValue < Min) || (iValue > Max))
                {
                    MessageBox.Show("Value out of range", this.Text);
                    if (sObject != null)
                    {
                        if (sObject.GetType() != typeof(DataGridViewTextBoxCell))
                        {
                            ((TextBox)sObject).Focus();
                        }
                        else
                        {
                            DataGridViewTextBoxCell Cell = (DataGridViewTextBoxCell)sObject;
                            Cell.DataGridView.FirstDisplayedScrollingRowIndex = Cell.RowIndex;
                            Cell.DataGridView.FirstDisplayedScrollingColumnIndex = Cell.ColumnIndex;
                            Cell.DataGridView.Refresh();
                            Cell.DataGridView.CurrentCell = Cell.DataGridView.Rows[Cell.RowIndex].Cells[Cell.ColumnIndex];
                        }
                    }
                    throw new System.ApplicationException();
                }
            }
            catch
            {
                iValue = 0;
                throw new System.ApplicationException();
            }
        }

        private void TestValue(Object sObject, String Value, Int32 Min, out Int32 iValue)
        {
            try
            {
                TestValue(sObject, Value, out iValue);

                if (iValue < Min)
                {
                    MessageBox.Show("Value out of range", this.Text);
                    if (sObject != null)
                    {
                        if (sObject.GetType() != typeof(DataGridViewTextBoxCell))
                        {
                            ((TextBox)sObject).Focus();
                        }
                        else
                        {
                            DataGridViewTextBoxCell Cell = (DataGridViewTextBoxCell)sObject;
                            Cell.DataGridView.FirstDisplayedScrollingRowIndex = Cell.RowIndex;
                            Cell.DataGridView.FirstDisplayedScrollingColumnIndex = Cell.ColumnIndex;
                            Cell.DataGridView.Refresh();
                            Cell.DataGridView.CurrentCell = Cell.DataGridView.Rows[Cell.RowIndex].Cells[Cell.ColumnIndex];
                        }
                    }
                    throw new System.ApplicationException();
                }
            }
            catch
            {
                iValue = 0;
                throw new System.ApplicationException();
            }
        }

		private void B_Connect_Click(object sender, System.EventArgs e)
		{
			UInt64 ulStatus = 0;
			UInt64 ulInfo = 0;
            Int32 iIP0, iIP1, iIP2, iIP3 = 0;


			if ((TB_IPAddress_0.Text.ToString()== "") || (TB_IPAddress_1.Text.ToString()== "") || (TB_IPAddress_2.Text.ToString()== "") || (TB_IPAddress_3.Text.ToString()== ""))
			{
				MessageBox.Show("The IP address you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
			}
			else
			{
                try
                {
                    TestValue(TB_IPAddress_0, TB_IPAddress_0.Text, 0, 255, out iIP0);
                    TestValue(TB_IPAddress_1, TB_IPAddress_1.Text, 0, 255, out iIP1);
                    TestValue(TB_IPAddress_2, TB_IPAddress_2.Text, 0, 255, out iIP2);
                    TestValue(TB_IPAddress_3, TB_IPAddress_3.Text, 0, 255, out iIP3);

                    B_Start.Enabled = false;
                    MX_Common.Url = "http://" + TB_IPAddress_0.Text + "." + TB_IPAddress_1.Text + "." + TB_IPAddress_2.Text + "." + TB_IPAddress_3.Text + ":5555";
					MSXE351x.Url = MX_Common.Url;

					try
					{

						Response = MSXE351x.AnalogOutputGetStatus(0,out ulStatus,out ulInfo);
						if (Response.iReturnValue != 0)
						{
							MessageBox.Show("AnalogOutputGetStatus Error : " + Response.iReturnValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
						}
						else
						{
                            GB_Channel.Enabled = true;
                            GB_Action.Enabled = true;
                            GB_StopState.Enabled = true;
                            GB_SamplingRate.Enabled = true;
                            GB_Datas.Enabled = true;
                            B_Start.Enabled = true;
                            B_Stop.Enabled = false;
                        }
					}
					catch(Exception ex)
					{
						MessageBox.Show("AnalogOutputGetStatus Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
					}
                }
                catch
                {
                }
			}
		}

        private void F_Main_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (B_Stop.Enabled == true)
            {
                B_Stop_Click(null, null);
            }
        }

        private void B_LoadSCV_Click(object sender, EventArgs e)
        {
            Int32 iLineIndex = 0;
            bool boReadIndex2 = true;
            bool boError = false;
            DataTable Datas = new DataTable();
            Int32 iValue0, iValue1 = 0;

            /* CSV, txt file selection */
            if (CSVOpenDialog.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                try
                {
                    string strConn = @"Driver={Microsoft Text Driver (*.txt; *.csv)}; Dbq=" + System.IO.Path.GetDirectoryName(CSVOpenDialog.FileName) + "; Extensions=asc,csv,txt; ";

                    OdbcConnection Conn = new OdbcConnection(strConn);
                    OdbcCommand File = new OdbcCommand("SELECT * FROM " + System.IO.Path.GetFileName(CSVOpenDialog.FileName), Conn);
                    Conn.Open();
                    OdbcDataReader Read = File.ExecuteReader(CommandBehavior.SequentialAccess);

                    Datas.Columns.Add("Time step", typeof(int));
                    Datas.Columns.Add("Analog value", typeof(int));

                    /* Read the file */
                    while (boError == false && Read.Read())
                    {
                        if (Read.IsDBNull(0) == false)
                        {
                            try
                            {
                                iValue0 = Read.GetInt32(0);

                                try
                                {
                                    if (boReadIndex2 == true)
                                    {
                                        iValue1 = Read.GetInt32(1);
                                        Datas.Rows.Add(iValue0, iValue1);
                                    }
                                    else
                                    {
                                        Datas.Rows.Add(1, iValue0);
                                    }

                                }
                                catch
                                {
                                    if ((boReadIndex2 == true) && (iLineIndex == 0))
                                    {
                                        boReadIndex2 = false;
                                        Datas.Rows.Add(1, iValue0);
                                    }
                                    else
                                    {
                                        MessageBox.Show("File format error", this.Text);
                                        boError = true;
                                    }
                                }
                            }
                            catch
                            {
                                MessageBox.Show("File format error", this.Text);
                                boError = true;
                            }

                            iLineIndex = iLineIndex + 1;
                        }
                    }
                    Conn.Close();
                }
                catch
                {
                    MessageBox.Show("File access error", this.Text);
                    boError = true;
                }

                /* Test if read any datas */
                if ((iLineIndex == 0) && (boError == false))
                {
                    MessageBox.Show("File format error", this.Text);
                }
                /* Test if no error occur */
                else if (boError == false)
                {
                    DGW_Datas.DataSource = null;
                    DGW_Datas.Rows.Clear();
                    DGW_Datas.DataSource = Datas;
                    DGW_Datas.Columns[0].Width = (DGW_Datas.Width / 2) - 30;
                    DGW_Datas.Columns[1].Width = (DGW_Datas.Width / 2) - 30;
                    if (boReadIndex2 == true)
                    {

                        try
                        {
                            if (Convert.ToInt32(TB_FixedTimeStep.Text) != 0)
                            {
                                TB_FixedTimeStep.Text = "0";
                            }
                        }
                        catch
                        {
                            TB_FixedTimeStep.Text = "0";
                        }
                    }
                    else
                    {
                        try
                        {
                            if (Convert.ToInt32(TB_FixedTimeStep.Text) == 0)
                            {
                                TB_FixedTimeStep.Text = "1";
                            }
                        }
                        catch
                        {
                            TB_FixedTimeStep.Text = "1";
                        }
                    }
                }
            }
        }

        private void TB_FixedTimeStep_TextChanged(object sender, EventArgs e)
        {
            int iFixedTimeStep = 0;

            try
            {
                if (TB_FixedTimeStep.Text != "")
                {
                    TestValue(TB_FixedTimeStep, TB_FixedTimeStep.Text, 0, 65535, out iFixedTimeStep);

                    if (iFixedTimeStep != 0)
                    {
                        DGW_Datas.Columns[0].ReadOnly = true;
                        DGW_Datas.Columns[0].DefaultCellStyle.BackColor = Color.LightGray;
                        DGW_Datas.Columns[0].DefaultCellStyle.ForeColor = Color.DarkGray;
                    }
                    else
                    {
                        DGW_Datas.Columns[0].ReadOnly = false;
                        DGW_Datas.Columns[0].DefaultCellStyle.BackColor = DGW_Datas.Columns[1].DefaultCellStyle.BackColor;
                        DGW_Datas.Columns[0].DefaultCellStyle.ForeColor = DGW_Datas.Columns[1].DefaultCellStyle.ForeColor;
                    }
                }
            }
            catch
            {
            }
        }

        private void DGW_Datas_CellEndEdit(object sender, DataGridViewCellEventArgs e)
        {
            if (e.ColumnIndex == 1)
            {
                if (DGW_Datas.Rows[e.RowIndex].Cells[0].Value != null && DGW_Datas.Rows[e.RowIndex].Cells[0].Value.ToString() == "")
                {
                    DGW_Datas.Rows[e.RowIndex].Cells[0].Value = 1;
                }
            }
        }

        private void DGW_Datas_CellValidating(object sender, DataGridViewCellValidatingEventArgs e)
        {
            int iValue = 0;

            if ((e.FormattedValue.ToString() != "") || (e.RowIndex < (DGW_Datas.RowCount - 1)))
            {
                if (e.ColumnIndex == 0)
                {
                    try
                    {
                        TestValue(null, e.FormattedValue.ToString(), 1, 65535, out iValue);
                    }
                    catch
                    {
                        DGW_Datas.EndEdit();
                        DGW_Datas.Rows[e.RowIndex].Cells[0].Value = 1;
                    }
                }
                else
                {
                    try
                    {
                        TestValue(null, e.FormattedValue.ToString(), 0, 65535, out iValue);
                    }
                    catch
                    {
                        DGW_Datas.EndEdit();
                        DGW_Datas.Rows[e.RowIndex].Cells[0].Value = 0;
                    }
                }
            }
        }

        private void DGW_Datas_DataError(object sender, DataGridViewDataErrorEventArgs e)
        {
            e.ThrowException = false;
        }

        private void B_Start_Click(object sender, EventArgs e)
        {
            Int32 iPrescaller = 0;
            Int32 iFixedTimeStep = 0;
            Int32 iMinValues = 0;
            int syserno = 0;
            int iReturnValue = 0;
            int iValue0 = 0;
            int iValue1 = 0;

            uValues = null;
            ulValues = null;

            // Stop the generator
            B_Stop_Click(null, null);

            // Configuration test
            try
            {
                if (CB_SamplingRate.SelectedIndex > 1)
                {
                    TestValue(TB_Prescaller, TB_Prescaller.Text, 1, out iPrescaller);
                }
                TestValue(TB_FixedTimeStep, TB_FixedTimeStep.Text, 0, out iFixedTimeStep);
                TestValue(TB_MinValue, TB_MinValue.Text, 1, 65535, out iMinValues);

                if (DGW_Datas.Rows.Count >= 1)
                {
                    if (iFixedTimeStep == 0)
                    {
                        ulValues = new ulong[DGW_Datas.Rows.Count - 1];
                        bValues = new byte[(DGW_Datas.Rows.Count - 1) * 4];

                        for (int i = 0; i < (DGW_Datas.Rows.Count - 1); i++)
                        {
                            TestValue(DGW_Datas.Rows[i].Cells[0], DGW_Datas.Rows[i].Cells[0].Value.ToString(), 1, 65535, out iValue0);
                            TestValue(DGW_Datas.Rows[i].Cells[1], DGW_Datas.Rows[i].Cells[1].Value.ToString(), 0, 65535, out iValue1);
                            ulValues[i] = (Convert.ToUInt32(iValue0) << 16) | Convert.ToUInt32(iValue1);
                            bValues[(i * 4) + 0] = (byte)(ulValues[i] >> 0);
                            bValues[(i * 4) + 1] = (byte)(ulValues[i] >> 8);
                            bValues[(i * 4) + 2] = (byte)(ulValues[i] >> 16);
                            bValues[(i * 4) + 3] = (byte)(ulValues[i] >> 24);
                        }
                    }
                    else
                    {
                        uValues = new ushort[DGW_Datas.Rows.Count - 1];
                        bValues = new byte[(DGW_Datas.Rows.Count - 1) * 2];

                        for (int i = 0; i < (DGW_Datas.Rows.Count - 1); i++)
                        {
                            TestValue(DGW_Datas.Rows[i].Cells[1], DGW_Datas.Rows[i].Cells[1].Value.ToString(), 0, 65535, out iValue1);
                            uValues[i] = Convert.ToUInt16(DGW_Datas.Rows[i].Cells[1].Value);
                            bValues[(i * 2) + 0] = (byte)(uValues[i] >> 0);
                            bValues[(i * 2) + 1] = (byte)(uValues[i] >> 8);
                        }
                    }
                }
                else
                {
                    MessageBox.Show("Sampling array is empty", this.Text, MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    return;
                }
            }
            catch
            {
                return;
            }

            // Test if socket connection selected
            if (CB_Source.SelectedIndex == 1)
            {
                try
                {
                    // Open the socket connection to receive the data
                    SocketClient = null;
                    SocketClient = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
                    SocketClient.SendBufferSize = 1048576;
                    SocketClient.Connect(TB_IPAddress_0.Text + "." + TB_IPAddress_1.Text + "." + TB_IPAddress_2.Text + "." + TB_IPAddress_3.Text, 9090 + CB_Channel.SelectedIndex);
                }
                catch (Exception ex)
                {
                    MessageBox.Show("Socket connection Exception occur : " + ex.Message + "\nSet the data receiver sever configuration to:\n-Server mode\n-TCP\n-Port number 9090", "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    return;
                }
            }

            try
            {
                // Sampling rate initialisation
                iReturnValue = MSXE351x.GeneratorInitSamplingRate((ulong)CB_SamplingRate.SelectedIndex, (ulong)iPrescaller, 0, 0, out syserno);

                if (iReturnValue != 0)
                {
                    MessageBox.Show("GeneratorInitSamplingRate Error : " + iReturnValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    B_Stop_Click(null, null);
                    return;
                }
            }

            catch (Exception ex)
            {
                MessageBox.Show("GeneratorInitSamplingRate Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                B_Stop_Click(null, null);
                return;
            }

            // Generator initialisation
            try
            {
                iReturnValue = MSXE351x.GeneratorInitContinuous((ulong)CB_Channel.SelectedIndex, (ulong)CB_OutputType.SelectedIndex, (ulong)CB_Polarity.SelectedIndex, (ulong)iMinValues, (ulong)iFixedTimeStep,
                                                                (ulong)CB_TriggerGate.SelectedIndex, (ulong)(CB_TriggerAction.SelectedIndex + 1), 0, (ulong)(CB_StopMode0.SelectedIndex + (CB_StopMode1.SelectedIndex * 2)),
                                                                (ulong)CB_Source.SelectedIndex + 1, 0, 0, out syserno);

                if (iReturnValue != 0)
                {
                    MessageBox.Show("GeneratorInitContinuous Error : " + iReturnValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    B_Stop_Click(null, null);
                    return;
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("GeneratorInitContinuous Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                B_Stop_Click(null, null);
                return;
            }

            // Thread installation

            // Test if SOAP
            if (CB_Source.SelectedIndex == 0)
            {
                // Test if not fixed time step
                if (iFixedTimeStep == 0)
                {
                    ClientThread = new Thread(SOAPWithTimeStepThreadFct);
                }
                else
                {
                    ClientThread = new Thread(SOAPWithoutTimeStepThreadFct);
                }
            }
            else
            {
                ClientThread = new Thread(SocketThreadFct);
            }

            // Thread start
            ulChannel = (ulong)CB_Channel.SelectedIndex;
            boExitWrite = false;
            ClientThread.Priority = ThreadPriority.Highest;
            ClientThread.Start();

            // Wait 250ms for the thread start and write datas
            System.Threading.Thread.Sleep(250);

            // Start the generator
            try
            {
                /* Start the generator */
                iReturnValue = MSXE351x.GeneratorStart(1UL << CB_Channel.SelectedIndex, 0, 0, out syserno);
                if (iReturnValue != 0)
                {
                    MessageBox.Show("GeneratorStart Error : " + iReturnValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    B_Stop_Click(null, null);
                }
                else
                {
                    B_Start.Enabled = false;
                    B_Stop.Enabled = true;
                    GB_Channel.Enabled = false;
                    GB_Action.Enabled = false;
                    GB_StopState.Enabled = false;
                    GB_SamplingRate.Enabled = false;
                    GB_Datas.Enabled = false;
                    B_Start.Enabled = false;
                    B_Connect.Enabled = false;
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("GeneratorStart Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                B_Stop_Click(null, null);
            }
        }

        private void B_Stop_Click(object sender, EventArgs e)
        {
            int syserno = 0;
            int iReturnValue = 0;

            boExitWrite = true;

            if (SocketClient != null)
            {
                try
                {
                    // Close the socket connection
                    SocketClient.Shutdown(SocketShutdown.Both);
                    SocketClient.Disconnect(false);
                    SocketClient.Close();
                    SocketClient = null;
                    System.GC.Collect();
                }
                catch (Exception ex)
                {
                    MessageBox.Show("Socket close connection exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
            }

            B_Start.Enabled = true;
            B_Stop.Enabled = false;
            GB_Channel.Enabled = true;
            GB_Action.Enabled = true;
            GB_StopState.Enabled = true;
            GB_SamplingRate.Enabled = true;
            GB_Datas.Enabled = true;
            B_Start.Enabled = true;
            B_Connect.Enabled = true;

            try
            {
                /* Start the generator */
                iReturnValue = MSXE351x.GeneratorStopAndRelease(1UL << CB_Channel.SelectedIndex, 0, 0, out syserno);
                if ((iReturnValue != 0) && (sender != null))
                {
                    MessageBox.Show("GeneratorStopAndRelease Error : " + iReturnValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
            }
            catch (Exception ex)
            {
                if (sender != null)
                {
                    MessageBox.Show("GeneratorStopAndRelease Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
            }
        }

        private void SOAPWithTimeStepThreadFct()
        {
            MSXE351x_WebReference.DefaultResponse Response;
            ulong   ulMaxWriteSize = (ulong) ulValues.Length;
            ulong   ulValueWrites  = (ulong) ulValues.Length;

            while (boExitWrite == false)
            {
                try
                {
                    ulong[] ulWriteDatas = new ulong[(ulValueWrites == ulMaxWriteSize ? ulMaxWriteSize : ulMaxWriteSize - ulValueWrites)];
                    Array.Copy(ulValues, (ulValueWrites == ulMaxWriteSize ? 0 : (int)ulValueWrites), ulWriteDatas, 0, ulWriteDatas.Length);

                    /* Write the datas */
                    Response = MSXE351x.GeneratorWriteDataWithSteps(ulChannel, ulWriteDatas, 0, 0, out ulValueWrites);

                    if (Response.iReturnValue != 0)
                    {
                        MessageBox.Show("GeneratorWriteDataWithSteps Error : " + Response.iReturnValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        StopCallback Stop = new StopCallback(B_Stop_Click);
                        this.Invoke(Stop, new object[] { null, null });
                        break;
                    }
                }
                catch (Exception ex)
                {
                    MessageBox.Show("GeneratorWriteDataWithSteps Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    StopCallback Stop = new StopCallback(B_Stop_Click);
                    this.Invoke(Stop, new object[] { null, null });
                    break;
                }
            }
        }

        private void SOAPWithoutTimeStepThreadFct()
        {
            MSXE351x_WebReference.DefaultResponse Response;
            ulong   ulMaxWriteSize = (ulong) uValues.Length;
            ulong   ulValueWrites  = (ulong) uValues.Length;

            while (boExitWrite == false)
            {
                try
                {
                    ushort[] uWriteDatas = new ushort[(ulValueWrites == ulMaxWriteSize ? ulMaxWriteSize : ulMaxWriteSize - ulValueWrites)];
                    Array.Copy(uValues, (ulValueWrites == ulMaxWriteSize ? 0 : (int)ulValueWrites), uWriteDatas, 0, uWriteDatas.Length);

                    /* Write the datas */
                    Response = MSXE351x.GeneratorWriteDataWithoutSteps(ulChannel, uWriteDatas, 0, 0, out ulValueWrites);

                    if (Response.iReturnValue != 0)
                    {
                        MessageBox.Show("GeneratorWriteDataWithoutSteps Error : " + Response.iReturnValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        StopCallback Stop = new StopCallback(B_Stop_Click);
                        this.Invoke(Stop, new object[] { null, null });
                        break;
                    }
                }
                catch (Exception ex)
                {
                    MessageBox.Show("GeneratorWriteDataWithoutSteps Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    StopCallback Stop = new StopCallback(B_Stop_Click);
                    this.Invoke(Stop, new object[] { null, null });
                    break;
                }
            }
        }

        private void SocketThreadFct()
        {
            int iMaxWriteSize = bValues.Length;
            int iValueWrites = bValues.Length;

            while (boExitWrite == false)
            {
                try
                {
                    // Send the datas
                    iValueWrites = SocketClient.Send(bValues, (iValueWrites == iMaxWriteSize ? 0 : iValueWrites), (iValueWrites == iMaxWriteSize ? iMaxWriteSize : iMaxWriteSize - iValueWrites), SocketFlags.None);

                    if ((iValueWrites < 0) && (boExitWrite == false))
                    {
                        MessageBox.Show("MSX-E system have close the socket connection.\nThis stop the sample", "MSX-E sample error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        StopCallback Stop = new StopCallback(B_Stop_Click);
                        this.Invoke(Stop, new object[] { null, null });
                        break;
                    }
                }
                catch (Exception ex)
                {
                    if (boExitWrite == false)
                    {
                        MessageBox.Show("Socket send exception occur : " + ex.Message, "MSX-E sample error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        StopCallback Stop = new StopCallback(B_Stop_Click);
                        this.Invoke(Stop, new object[] { null, null });
                    }
                    break;
                }
            }
        }
	}
}
