using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Threading;

namespace AnalogOutputFormula
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class F_Main : System.Windows.Forms.Form
    {
		private System.Windows.Forms.GroupBox GB_Help;
		private System.Windows.Forms.Label L_Help;
		private System.Windows.Forms.GroupBox GB_Description;
		private System.Windows.Forms.Label L_Description;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox TB_IPAddress_3;
		private System.Windows.Forms.TextBox TB_IPAddress_2;
		private System.Windows.Forms.TextBox TB_IPAddress_1;
		private System.Windows.Forms.TextBox TB_IPAddress_0;
		private System.Windows.Forms.Label label19;
        private System.Windows.Forms.GroupBox GB_Channel;
		private System.Windows.Forms.Button B_Connect;
		private System.Windows.Forms.ComboBox CB_Channel;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.ComboBox CB_OutputType;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.ComboBox CB_Polarity;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.ComboBox CB_TriggerGate;
        private System.Windows.Forms.Label label7;
        private GroupBox GB_Action;
        private Label label10;
        private ComboBox CB_TriggerAction;
        private GroupBox GB_SamplingRate;
        private Label label8;
        private Label label9;
        private ComboBox CB_SamplingRate;
        private TextBox TB_Prescaller;
        private GroupBox GB_StopState;
        private Label label11;
        private Label label13;
        private ComboBox CB_StopMode0;
        private ComboBox CB_StopMode1;
        private GroupBox GB_Formula;
        private Label label12;
        private Label label14;
        private ComboBox CB_Frequency;
        private ComboBox CB_Formula;
        private Label label16;
        private Label label15;
        private TextBox TB_XEnd;
        private TextBox TB_XStart;
        private Label label17;
        private TextBox TB_TimeStep;
        private Label label18;
        private TextBox TB_Cycles;
        private Label label20;
        private TextBox TB_Formula;
        private Button B_Start;
        private Button B_Stop;
        private Button button1;
		private System.ComponentModel.IContainer components;

		public F_Main()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(F_Main));
            this.GB_Help = new System.Windows.Forms.GroupBox();
            this.L_Help = new System.Windows.Forms.Label();
            this.GB_Description = new System.Windows.Forms.GroupBox();
            this.L_Description = new System.Windows.Forms.Label();
            this.B_Connect = new System.Windows.Forms.Button();
            this.label3 = new System.Windows.Forms.Label();
            this.label1 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.TB_IPAddress_3 = new System.Windows.Forms.TextBox();
            this.TB_IPAddress_2 = new System.Windows.Forms.TextBox();
            this.TB_IPAddress_1 = new System.Windows.Forms.TextBox();
            this.TB_IPAddress_0 = new System.Windows.Forms.TextBox();
            this.label19 = new System.Windows.Forms.Label();
            this.GB_Channel = new System.Windows.Forms.GroupBox();
            this.label6 = new System.Windows.Forms.Label();
            this.CB_Polarity = new System.Windows.Forms.ComboBox();
            this.label5 = new System.Windows.Forms.Label();
            this.CB_OutputType = new System.Windows.Forms.ComboBox();
            this.label4 = new System.Windows.Forms.Label();
            this.CB_Channel = new System.Windows.Forms.ComboBox();
            this.label7 = new System.Windows.Forms.Label();
            this.CB_TriggerGate = new System.Windows.Forms.ComboBox();
            this.GB_Action = new System.Windows.Forms.GroupBox();
            this.label10 = new System.Windows.Forms.Label();
            this.CB_TriggerAction = new System.Windows.Forms.ComboBox();
            this.GB_SamplingRate = new System.Windows.Forms.GroupBox();
            this.label8 = new System.Windows.Forms.Label();
            this.label9 = new System.Windows.Forms.Label();
            this.CB_SamplingRate = new System.Windows.Forms.ComboBox();
            this.TB_Prescaller = new System.Windows.Forms.TextBox();
            this.GB_StopState = new System.Windows.Forms.GroupBox();
            this.label11 = new System.Windows.Forms.Label();
            this.label13 = new System.Windows.Forms.Label();
            this.CB_StopMode1 = new System.Windows.Forms.ComboBox();
            this.CB_StopMode0 = new System.Windows.Forms.ComboBox();
            this.GB_Formula = new System.Windows.Forms.GroupBox();
            this.label20 = new System.Windows.Forms.Label();
            this.label18 = new System.Windows.Forms.Label();
            this.label17 = new System.Windows.Forms.Label();
            this.label16 = new System.Windows.Forms.Label();
            this.label15 = new System.Windows.Forms.Label();
            this.TB_Formula = new System.Windows.Forms.TextBox();
            this.TB_Cycles = new System.Windows.Forms.TextBox();
            this.label12 = new System.Windows.Forms.Label();
            this.TB_TimeStep = new System.Windows.Forms.TextBox();
            this.label14 = new System.Windows.Forms.Label();
            this.TB_XEnd = new System.Windows.Forms.TextBox();
            this.TB_XStart = new System.Windows.Forms.TextBox();
            this.CB_Frequency = new System.Windows.Forms.ComboBox();
            this.CB_Formula = new System.Windows.Forms.ComboBox();
            this.B_Start = new System.Windows.Forms.Button();
            this.B_Stop = new System.Windows.Forms.Button();
            this.button1 = new System.Windows.Forms.Button();
            this.GB_Help.SuspendLayout();
            this.GB_Description.SuspendLayout();
            this.GB_Channel.SuspendLayout();
            this.GB_Action.SuspendLayout();
            this.GB_SamplingRate.SuspendLayout();
            this.GB_StopState.SuspendLayout();
            this.GB_Formula.SuspendLayout();
            this.SuspendLayout();
            // 
            // GB_Help
            // 
            this.GB_Help.Controls.Add(this.L_Help);
            this.GB_Help.Location = new System.Drawing.Point(16, 88);
            this.GB_Help.Name = "GB_Help";
            this.GB_Help.Size = new System.Drawing.Size(621, 56);
            this.GB_Help.TabIndex = 44;
            this.GB_Help.TabStop = false;
            this.GB_Help.Text = "Help";
            // 
            // L_Help
            // 
            this.L_Help.Location = new System.Drawing.Point(8, 16);
            this.L_Help.Name = "L_Help";
            this.L_Help.Size = new System.Drawing.Size(594, 32);
            this.L_Help.TabIndex = 0;
            this.L_Help.Text = "You must first enter the IP address of the MSX-E351x system, than click on button" +
                " \"Connect\".";
            // 
            // GB_Description
            // 
            this.GB_Description.Controls.Add(this.L_Description);
            this.GB_Description.Location = new System.Drawing.Point(16, 16);
            this.GB_Description.Name = "GB_Description";
            this.GB_Description.Size = new System.Drawing.Size(621, 64);
            this.GB_Description.TabIndex = 43;
            this.GB_Description.TabStop = false;
            this.GB_Description.Text = "Description";
            // 
            // L_Description
            // 
            this.L_Description.Location = new System.Drawing.Point(8, 16);
            this.L_Description.Name = "L_Description";
            this.L_Description.Size = new System.Drawing.Size(598, 30);
            this.L_Description.TabIndex = 0;
            this.L_Description.Text = "This sample  permit to write the analog values via a math formula";
            // 
            // B_Connect
            // 
            this.B_Connect.Location = new System.Drawing.Point(447, 150);
            this.B_Connect.Name = "B_Connect";
            this.B_Connect.Size = new System.Drawing.Size(190, 32);
            this.B_Connect.TabIndex = 40;
            this.B_Connect.Text = "Connect";
            this.B_Connect.Click += new System.EventHandler(this.B_Connect_Click);
            // 
            // label3
            // 
            this.label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label3.Location = new System.Drawing.Point(384, 157);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(8, 16);
            this.label3.TabIndex = 39;
            this.label3.Text = "-";
            // 
            // label1
            // 
            this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label1.Location = new System.Drawing.Point(328, 157);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(8, 16);
            this.label1.TabIndex = 38;
            this.label1.Text = "-";
            // 
            // label2
            // 
            this.label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label2.Location = new System.Drawing.Point(272, 157);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(8, 16);
            this.label2.TabIndex = 37;
            this.label2.Text = "-";
            // 
            // TB_IPAddress_3
            // 
            this.TB_IPAddress_3.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.TB_IPAddress_3.Location = new System.Drawing.Point(400, 157);
            this.TB_IPAddress_3.MaxLength = 3;
            this.TB_IPAddress_3.Name = "TB_IPAddress_3";
            this.TB_IPAddress_3.Size = new System.Drawing.Size(32, 20);
            this.TB_IPAddress_3.TabIndex = 36;
            this.TB_IPAddress_3.Enter += new System.EventHandler(this.TB_IPAddress_3_Enter);
            // 
            // TB_IPAddress_2
            // 
            this.TB_IPAddress_2.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.TB_IPAddress_2.Location = new System.Drawing.Point(344, 157);
            this.TB_IPAddress_2.MaxLength = 3;
            this.TB_IPAddress_2.Name = "TB_IPAddress_2";
            this.TB_IPAddress_2.Size = new System.Drawing.Size(32, 20);
            this.TB_IPAddress_2.TabIndex = 35;
            this.TB_IPAddress_2.Enter += new System.EventHandler(this.TB_IPAddress_2_Enter);
            // 
            // TB_IPAddress_1
            // 
            this.TB_IPAddress_1.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.TB_IPAddress_1.Location = new System.Drawing.Point(288, 157);
            this.TB_IPAddress_1.MaxLength = 3;
            this.TB_IPAddress_1.Name = "TB_IPAddress_1";
            this.TB_IPAddress_1.Size = new System.Drawing.Size(32, 20);
            this.TB_IPAddress_1.TabIndex = 34;
            this.TB_IPAddress_1.Enter += new System.EventHandler(this.TB_IPAddress_1_Enter);
            // 
            // TB_IPAddress_0
            // 
            this.TB_IPAddress_0.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.TB_IPAddress_0.ImeMode = System.Windows.Forms.ImeMode.Disable;
            this.TB_IPAddress_0.Location = new System.Drawing.Point(232, 157);
            this.TB_IPAddress_0.MaxLength = 3;
            this.TB_IPAddress_0.Name = "TB_IPAddress_0";
            this.TB_IPAddress_0.Size = new System.Drawing.Size(32, 20);
            this.TB_IPAddress_0.TabIndex = 33;
            this.TB_IPAddress_0.Enter += new System.EventHandler(this.TB_IPAddress_0_Enter);
            // 
            // label19
            // 
            this.label19.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label19.Location = new System.Drawing.Point(18, 157);
            this.label19.Name = "label19";
            this.label19.Size = new System.Drawing.Size(208, 16);
            this.label19.TabIndex = 32;
            this.label19.Text = "IP address of the MSX-E351x system :";
            // 
            // GB_Channel
            // 
            this.GB_Channel.Controls.Add(this.label6);
            this.GB_Channel.Controls.Add(this.CB_Polarity);
            this.GB_Channel.Controls.Add(this.label5);
            this.GB_Channel.Controls.Add(this.CB_OutputType);
            this.GB_Channel.Controls.Add(this.label4);
            this.GB_Channel.Controls.Add(this.CB_Channel);
            this.GB_Channel.Enabled = false;
            this.GB_Channel.Location = new System.Drawing.Point(16, 188);
            this.GB_Channel.Name = "GB_Channel";
            this.GB_Channel.Size = new System.Drawing.Size(264, 108);
            this.GB_Channel.TabIndex = 46;
            this.GB_Channel.TabStop = false;
            this.GB_Channel.Text = "Channel configuration";
            // 
            // label6
            // 
            this.label6.AutoSize = true;
            this.label6.Location = new System.Drawing.Point(6, 76);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(47, 13);
            this.label6.TabIndex = 5;
            this.label6.Text = "Polarity :";
            // 
            // CB_Polarity
            // 
            this.CB_Polarity.Items.AddRange(new object[] {
            "Unipolar",
            "Bipolar"});
            this.CB_Polarity.Location = new System.Drawing.Point(96, 73);
            this.CB_Polarity.Name = "CB_Polarity";
            this.CB_Polarity.Size = new System.Drawing.Size(78, 21);
            this.CB_Polarity.TabIndex = 4;
            this.CB_Polarity.Text = "Unipolar";
            // 
            // label5
            // 
            this.label5.AutoSize = true;
            this.label5.Location = new System.Drawing.Point(6, 51);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(68, 13);
            this.label5.TabIndex = 3;
            this.label5.Text = "Output type :";
            // 
            // CB_OutputType
            // 
            this.CB_OutputType.Items.AddRange(new object[] {
            "Voltage",
            "Current"});
            this.CB_OutputType.Location = new System.Drawing.Point(96, 46);
            this.CB_OutputType.Name = "CB_OutputType";
            this.CB_OutputType.Size = new System.Drawing.Size(78, 21);
            this.CB_OutputType.TabIndex = 2;
            this.CB_OutputType.Text = "Voltage";
            this.CB_OutputType.SelectedIndexChanged += new System.EventHandler(this.CB_OutputType_SelectedIndexChanged);
            // 
            // label4
            // 
            this.label4.AutoSize = true;
            this.label4.Location = new System.Drawing.Point(6, 24);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(55, 13);
            this.label4.TabIndex = 1;
            this.label4.Text = "Channel : ";
            // 
            // CB_Channel
            // 
            this.CB_Channel.Items.AddRange(new object[] {
            "0",
            "1",
            "2",
            "3",
            "4",
            "5",
            "6",
            "7"});
            this.CB_Channel.Location = new System.Drawing.Point(96, 19);
            this.CB_Channel.Name = "CB_Channel";
            this.CB_Channel.Size = new System.Drawing.Size(78, 21);
            this.CB_Channel.TabIndex = 0;
            this.CB_Channel.Text = "0";
            // 
            // label7
            // 
            this.label7.AutoSize = true;
            this.label7.Location = new System.Drawing.Point(8, 22);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(133, 13);
            this.label7.TabIndex = 7;
            this.label7.Text = "Extern gate/trigger source:";
            // 
            // CB_TriggerGate
            // 
            this.CB_TriggerGate.Items.AddRange(new object[] {
            "Disabled",
            "Hardware trigger",
            "Synchro trigger (one shot)"});
            this.CB_TriggerGate.Location = new System.Drawing.Point(167, 19);
            this.CB_TriggerGate.Name = "CB_TriggerGate";
            this.CB_TriggerGate.Size = new System.Drawing.Size(163, 21);
            this.CB_TriggerGate.TabIndex = 6;
            this.CB_TriggerGate.Text = "Disabled";
            this.CB_TriggerGate.SelectedIndexChanged += new System.EventHandler(this.CB_TriggerGate_SelectedIndexChanged);
            // 
            // GB_Action
            // 
            this.GB_Action.Controls.Add(this.label10);
            this.GB_Action.Controls.Add(this.label7);
            this.GB_Action.Controls.Add(this.CB_TriggerAction);
            this.GB_Action.Controls.Add(this.CB_TriggerGate);
            this.GB_Action.Enabled = false;
            this.GB_Action.Location = new System.Drawing.Point(288, 188);
            this.GB_Action.Name = "GB_Action";
            this.GB_Action.Size = new System.Drawing.Size(349, 108);
            this.GB_Action.TabIndex = 46;
            this.GB_Action.TabStop = false;
            this.GB_Action.Text = "Extern gate/trigger configuration";
            // 
            // label10
            // 
            this.label10.AutoSize = true;
            this.label10.Location = new System.Drawing.Point(8, 49);
            this.label10.Name = "label10";
            this.label10.Size = new System.Drawing.Size(152, 13);
            this.label10.TabIndex = 7;
            this.label10.Text = "Hardware trigger input acction:";
            // 
            // CB_TriggerAction
            // 
            this.CB_TriggerAction.Enabled = false;
            this.CB_TriggerAction.Items.AddRange(new object[] {
            "Rising front trigger (one shot)",
            "Falling front trigger (one shot)",
            "Both front trigger (one shot)",
            "High level gate",
            "Low level gate"});
            this.CB_TriggerAction.Location = new System.Drawing.Point(166, 46);
            this.CB_TriggerAction.Name = "CB_TriggerAction";
            this.CB_TriggerAction.Size = new System.Drawing.Size(164, 21);
            this.CB_TriggerAction.TabIndex = 6;
            this.CB_TriggerAction.Text = "Rising front trigger (one shot)";
            this.CB_TriggerAction.SelectedIndexChanged += new System.EventHandler(this.CB_TriggerAction_SelectedIndexChanged);
            // 
            // GB_SamplingRate
            // 
            this.GB_SamplingRate.Controls.Add(this.label8);
            this.GB_SamplingRate.Controls.Add(this.label9);
            this.GB_SamplingRate.Controls.Add(this.CB_SamplingRate);
            this.GB_SamplingRate.Controls.Add(this.TB_Prescaller);
            this.GB_SamplingRate.Enabled = false;
            this.GB_SamplingRate.Location = new System.Drawing.Point(288, 302);
            this.GB_SamplingRate.Name = "GB_SamplingRate";
            this.GB_SamplingRate.Size = new System.Drawing.Size(349, 83);
            this.GB_SamplingRate.TabIndex = 46;
            this.GB_SamplingRate.TabStop = false;
            this.GB_SamplingRate.Text = "Sampling rate";
            // 
            // label8
            // 
            this.label8.AutoSize = true;
            this.label8.Location = new System.Drawing.Point(8, 52);
            this.label8.Name = "label8";
            this.label8.Size = new System.Drawing.Size(59, 13);
            this.label8.TabIndex = 7;
            this.label8.Text = "Prescaller :";
            // 
            // label9
            // 
            this.label9.AutoSize = true;
            this.label9.Location = new System.Drawing.Point(8, 22);
            this.label9.Name = "label9";
            this.label9.Size = new System.Drawing.Size(112, 13);
            this.label9.TabIndex = 7;
            this.label9.Text = "Sampling rate source :";
            // 
            // CB_SamplingRate
            // 
            this.CB_SamplingRate.Items.AddRange(new object[] {
            "20 kHz",
            "40 kHz",
            "Synchro trigger",
            "High hardware trigger input edge",
            "Low hardware trigger input edge",
            "High/low hardware trigger input edge"});
            this.CB_SamplingRate.Location = new System.Drawing.Point(126, 19);
            this.CB_SamplingRate.Name = "CB_SamplingRate";
            this.CB_SamplingRate.Size = new System.Drawing.Size(204, 21);
            this.CB_SamplingRate.TabIndex = 6;
            this.CB_SamplingRate.Text = "20 kHz";
            this.CB_SamplingRate.SelectedIndexChanged += new System.EventHandler(this.CB_SamplingRate_SelectedIndexChanged);
            // 
            // TB_Prescaller
            // 
            this.TB_Prescaller.Enabled = false;
            this.TB_Prescaller.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.TB_Prescaller.ImeMode = System.Windows.Forms.ImeMode.Disable;
            this.TB_Prescaller.Location = new System.Drawing.Point(126, 49);
            this.TB_Prescaller.MaxLength = 20;
            this.TB_Prescaller.Name = "TB_Prescaller";
            this.TB_Prescaller.Size = new System.Drawing.Size(204, 20);
            this.TB_Prescaller.TabIndex = 33;
            this.TB_Prescaller.Text = "0";
            this.TB_Prescaller.Enter += new System.EventHandler(this.TB_IPAddress_0_Enter);
            // 
            // GB_StopState
            // 
            this.GB_StopState.Controls.Add(this.label11);
            this.GB_StopState.Controls.Add(this.label13);
            this.GB_StopState.Controls.Add(this.CB_StopMode1);
            this.GB_StopState.Controls.Add(this.CB_StopMode0);
            this.GB_StopState.Enabled = false;
            this.GB_StopState.Location = new System.Drawing.Point(16, 302);
            this.GB_StopState.Name = "GB_StopState";
            this.GB_StopState.Size = new System.Drawing.Size(264, 83);
            this.GB_StopState.TabIndex = 46;
            this.GB_StopState.TabStop = false;
            this.GB_StopState.Text = "Stop state";
            // 
            // label11
            // 
            this.label11.AutoSize = true;
            this.label11.Location = new System.Drawing.Point(8, 49);
            this.label11.Name = "label11";
            this.label11.Size = new System.Drawing.Size(188, 13);
            this.label11.TabIndex = 5;
            this.label11.Text = "Set to 0V/0mA after a stop command :";
            // 
            // label13
            // 
            this.label13.AutoSize = true;
            this.label13.Location = new System.Drawing.Point(8, 22);
            this.label13.Name = "label13";
            this.label13.Size = new System.Drawing.Size(179, 13);
            this.label13.TabIndex = 1;
            this.label13.Text = "Set to 0V/0mA after write all values :";
            // 
            // CB_StopMode1
            // 
            this.CB_StopMode1.Items.AddRange(new object[] {
            "No",
            "Yes"});
            this.CB_StopMode1.Location = new System.Drawing.Point(201, 46);
            this.CB_StopMode1.Name = "CB_StopMode1";
            this.CB_StopMode1.Size = new System.Drawing.Size(47, 21);
            this.CB_StopMode1.TabIndex = 0;
            this.CB_StopMode1.Text = "No";
            // 
            // CB_StopMode0
            // 
            this.CB_StopMode0.Items.AddRange(new object[] {
            "No",
            "Yes"});
            this.CB_StopMode0.Location = new System.Drawing.Point(201, 19);
            this.CB_StopMode0.Name = "CB_StopMode0";
            this.CB_StopMode0.Size = new System.Drawing.Size(47, 21);
            this.CB_StopMode0.TabIndex = 0;
            this.CB_StopMode0.Text = "No";
            // 
            // GB_Formula
            // 
            this.GB_Formula.Controls.Add(this.label20);
            this.GB_Formula.Controls.Add(this.label18);
            this.GB_Formula.Controls.Add(this.label17);
            this.GB_Formula.Controls.Add(this.label16);
            this.GB_Formula.Controls.Add(this.label15);
            this.GB_Formula.Controls.Add(this.TB_Formula);
            this.GB_Formula.Controls.Add(this.TB_Cycles);
            this.GB_Formula.Controls.Add(this.label12);
            this.GB_Formula.Controls.Add(this.TB_TimeStep);
            this.GB_Formula.Controls.Add(this.label14);
            this.GB_Formula.Controls.Add(this.TB_XEnd);
            this.GB_Formula.Controls.Add(this.TB_XStart);
            this.GB_Formula.Controls.Add(this.CB_Frequency);
            this.GB_Formula.Controls.Add(this.CB_Formula);
            this.GB_Formula.Enabled = false;
            this.GB_Formula.Location = new System.Drawing.Point(16, 391);
            this.GB_Formula.Name = "GB_Formula";
            this.GB_Formula.Size = new System.Drawing.Size(621, 132);
            this.GB_Formula.TabIndex = 46;
            this.GB_Formula.TabStop = false;
            this.GB_Formula.Text = "Formula";
            // 
            // label20
            // 
            this.label20.AutoSize = true;
            this.label20.Location = new System.Drawing.Point(12, 100);
            this.label20.Name = "label20";
            this.label20.Size = new System.Drawing.Size(26, 13);
            this.label20.TabIndex = 5;
            this.label20.Text = "Y = ";
            // 
            // label18
            // 
            this.label18.AutoSize = true;
            this.label18.Location = new System.Drawing.Point(12, 74);
            this.label18.Name = "label18";
            this.label18.Size = new System.Drawing.Size(183, 13);
            this.label18.TabIndex = 5;
            this.label18.Text = "Number of cycle(s), 0 for continuous :";
            // 
            // label17
            // 
            this.label17.AutoSize = true;
            this.label17.Location = new System.Drawing.Point(422, 74);
            this.label17.Name = "label17";
            this.label17.Size = new System.Drawing.Size(59, 13);
            this.label17.TabIndex = 5;
            this.label17.Text = "Time step :";
            // 
            // label16
            // 
            this.label16.AutoSize = true;
            this.label16.Location = new System.Drawing.Point(422, 48);
            this.label16.Name = "label16";
            this.label16.Size = new System.Drawing.Size(73, 13);
            this.label16.TabIndex = 5;
            this.label16.Text = "X end value  :";
            // 
            // label15
            // 
            this.label15.AutoSize = true;
            this.label15.Location = new System.Drawing.Point(422, 22);
            this.label15.Name = "label15";
            this.label15.Size = new System.Drawing.Size(75, 13);
            this.label15.TabIndex = 5;
            this.label15.Text = "X start value  :";
            // 
            // TB_Formula
            // 
            this.TB_Formula.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.TB_Formula.ImeMode = System.Windows.Forms.ImeMode.Disable;
            this.TB_Formula.Location = new System.Drawing.Point(44, 97);
            this.TB_Formula.MaxLength = 400;
            this.TB_Formula.Name = "TB_Formula";
            this.TB_Formula.Size = new System.Drawing.Size(562, 20);
            this.TB_Formula.TabIndex = 33;
            this.TB_Formula.Enter += new System.EventHandler(this.TB_IPAddress_0_Enter);
            // 
            // TB_Cycles
            // 
            this.TB_Cycles.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.TB_Cycles.ImeMode = System.Windows.Forms.ImeMode.Disable;
            this.TB_Cycles.Location = new System.Drawing.Point(201, 71);
            this.TB_Cycles.MaxLength = 20;
            this.TB_Cycles.Name = "TB_Cycles";
            this.TB_Cycles.Size = new System.Drawing.Size(103, 20);
            this.TB_Cycles.TabIndex = 33;
            this.TB_Cycles.Text = "0";
            this.TB_Cycles.Enter += new System.EventHandler(this.TB_IPAddress_0_Enter);
            // 
            // label12
            // 
            this.label12.AutoSize = true;
            this.label12.Location = new System.Drawing.Point(12, 49);
            this.label12.Name = "label12";
            this.label12.Size = new System.Drawing.Size(63, 13);
            this.label12.TabIndex = 5;
            this.label12.Text = "Frequency :";
            // 
            // TB_TimeStep
            // 
            this.TB_TimeStep.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.TB_TimeStep.ImeMode = System.Windows.Forms.ImeMode.Disable;
            this.TB_TimeStep.Location = new System.Drawing.Point(503, 71);
            this.TB_TimeStep.MaxLength = 20;
            this.TB_TimeStep.Name = "TB_TimeStep";
            this.TB_TimeStep.Size = new System.Drawing.Size(103, 20);
            this.TB_TimeStep.TabIndex = 33;
            this.TB_TimeStep.Text = "1";
            this.TB_TimeStep.Enter += new System.EventHandler(this.TB_IPAddress_0_Enter);
            // 
            // label14
            // 
            this.label14.AutoSize = true;
            this.label14.Location = new System.Drawing.Point(12, 22);
            this.label14.Name = "label14";
            this.label14.Size = new System.Drawing.Size(95, 13);
            this.label14.TabIndex = 1;
            this.label14.Text = "Formula selection :";
            // 
            // TB_XEnd
            // 
            this.TB_XEnd.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.TB_XEnd.ImeMode = System.Windows.Forms.ImeMode.Disable;
            this.TB_XEnd.Location = new System.Drawing.Point(503, 45);
            this.TB_XEnd.MaxLength = 20;
            this.TB_XEnd.Name = "TB_XEnd";
            this.TB_XEnd.Size = new System.Drawing.Size(103, 20);
            this.TB_XEnd.TabIndex = 33;
            this.TB_XEnd.Text = "0";
            this.TB_XEnd.Enter += new System.EventHandler(this.TB_IPAddress_0_Enter);
            // 
            // TB_XStart
            // 
            this.TB_XStart.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.TB_XStart.ImeMode = System.Windows.Forms.ImeMode.Disable;
            this.TB_XStart.Location = new System.Drawing.Point(503, 19);
            this.TB_XStart.MaxLength = 20;
            this.TB_XStart.Name = "TB_XStart";
            this.TB_XStart.Size = new System.Drawing.Size(103, 20);
            this.TB_XStart.TabIndex = 33;
            this.TB_XStart.Text = "0";
            this.TB_XStart.Enter += new System.EventHandler(this.TB_IPAddress_0_Enter);
            // 
            // CB_Frequency
            // 
            this.CB_Frequency.Enabled = false;
            this.CB_Frequency.Items.AddRange(new object[] {
            "1000 Hz",
            "500 Hz",
            "100 Hz",
            "50 Hz",
            "10 Hz",
            "5 Hz",
            "1 Hz"});
            this.CB_Frequency.Location = new System.Drawing.Point(201, 46);
            this.CB_Frequency.Name = "CB_Frequency";
            this.CB_Frequency.Size = new System.Drawing.Size(103, 21);
            this.CB_Frequency.TabIndex = 0;
            this.CB_Frequency.Text = "1000 Hz";
            this.CB_Frequency.SelectedIndexChanged += new System.EventHandler(this.CB_Frequency_SelectedIndexChanged);
            // 
            // CB_Formula
            // 
            this.CB_Formula.Items.AddRange(new object[] {
            "User selection",
            "Sinus",
            "Square",
            "Triangle"});
            this.CB_Formula.Location = new System.Drawing.Point(201, 19);
            this.CB_Formula.Name = "CB_Formula";
            this.CB_Formula.Size = new System.Drawing.Size(103, 21);
            this.CB_Formula.TabIndex = 0;
            this.CB_Formula.Text = "User selection";
            this.CB_Formula.SelectedIndexChanged += new System.EventHandler(this.CB_Formula_SelectedIndexChanged);
            // 
            // B_Start
            // 
            this.B_Start.Enabled = false;
            this.B_Start.Location = new System.Drawing.Point(16, 541);
            this.B_Start.Name = "B_Start";
            this.B_Start.Size = new System.Drawing.Size(190, 32);
            this.B_Start.TabIndex = 40;
            this.B_Start.Text = "Start the sample";
            this.B_Start.Click += new System.EventHandler(this.B_Start_Click);
            // 
            // B_Stop
            // 
            this.B_Stop.Enabled = false;
            this.B_Stop.Location = new System.Drawing.Point(447, 541);
            this.B_Stop.Name = "B_Stop";
            this.B_Stop.Size = new System.Drawing.Size(190, 32);
            this.B_Stop.TabIndex = 40;
            this.B_Stop.Text = "Stop the sample";
            this.B_Stop.Click += new System.EventHandler(this.B_Stop_Click);
            // 
            // button1
            // 
            this.button1.Location = new System.Drawing.Point(231, 541);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(190, 32);
            this.button1.TabIndex = 40;
            this.button1.Text = "Formula help";
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // F_Main
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(657, 614);
            this.Controls.Add(this.GB_SamplingRate);
            this.Controls.Add(this.GB_Action);
            this.Controls.Add(this.GB_Formula);
            this.Controls.Add(this.GB_StopState);
            this.Controls.Add(this.GB_Channel);
            this.Controls.Add(this.GB_Help);
            this.Controls.Add(this.GB_Description);
            this.Controls.Add(this.B_Stop);
            this.Controls.Add(this.button1);
            this.Controls.Add(this.B_Start);
            this.Controls.Add(this.B_Connect);
            this.Controls.Add(this.label3);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.TB_IPAddress_3);
            this.Controls.Add(this.TB_IPAddress_2);
            this.Controls.Add(this.TB_IPAddress_1);
            this.Controls.Add(this.TB_IPAddress_0);
            this.Controls.Add(this.label19);
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.Name = "F_Main";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "C# MSX-E351x : Analog output access via math formula";
            this.Load += new System.EventHandler(this.F_AnalogOutputFormula_Load);
            this.Closed += new System.EventHandler(this.F_AnalogOutputFormula_Closed);
            this.FormClosing += new System.Windows.Forms.FormClosingEventHandler(this.F_Main_FormClosing);
            this.GB_Help.ResumeLayout(false);
            this.GB_Description.ResumeLayout(false);
            this.GB_Channel.ResumeLayout(false);
            this.GB_Channel.PerformLayout();
            this.GB_Action.ResumeLayout(false);
            this.GB_Action.PerformLayout();
            this.GB_SamplingRate.ResumeLayout(false);
            this.GB_SamplingRate.PerformLayout();
            this.GB_StopState.ResumeLayout(false);
            this.GB_StopState.PerformLayout();
            this.GB_Formula.ResumeLayout(false);
            this.GB_Formula.PerformLayout();
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new F_Main());
		}

		// Global Variable
		MXCommon_WebReference.MXCommon MX_Common;
		MSXE351x_WebReference.MSXE351x MSXE351x;
		MSXE351x_WebReference.DefaultResponse Response;
        ulong ulTriggerAction = 1;

		private void F_AnalogOutputFormula_Load(object sender, System.EventArgs e)
		{
			MX_Common = new MXCommon_WebReference.MXCommon();
			MSXE351x = new MSXE351x_WebReference.MSXE351x();
			MX_Common.Timeout = 2000;
			MSXE351x.Timeout = 2000;
		}

		private void F_AnalogOutputFormula_Closed(object sender, System.EventArgs e)
		{
			if (MSXE351x != null)
				MSXE351x = null;
			if (MX_Common != null)
				MX_Common = null;

			System.GC.Collect();
		
		}

        private void CB_OutputType_SelectedIndexChanged(object sender, EventArgs e)
        {
            CB_Polarity.Enabled = (CB_OutputType.SelectedIndex == 0);
        }

        private void CB_TriggerGate_SelectedIndexChanged(object sender, EventArgs e)
        {
            CB_TriggerAction.Enabled = (CB_TriggerGate.SelectedIndex == 1);
        }

        private void CB_SamplingRate_SelectedIndexChanged(object sender, EventArgs e)
        {
            TB_Prescaller.Enabled = (CB_SamplingRate.SelectedIndex > 1);
            if (CB_SamplingRate.SelectedIndex > 1)
            {
                CB_Formula.SelectedIndex = 0;
            }
            else
            {
                TestUserFormualSelection();
            }

        }

        private void CB_Formula_SelectedIndexChanged(object sender, EventArgs e)
        {
            TB_XStart.Enabled = (CB_Formula.SelectedIndex == 0);
            TB_XEnd.Enabled = TB_XStart.Enabled;
            TB_TimeStep.Enabled = TB_XStart.Enabled;
            CB_Frequency.Enabled = !TB_XStart.Enabled;
            TB_Formula.Enabled = TB_XStart.Enabled;
            TestUserFormualSelection();
        }

        private void CB_Frequency_SelectedIndexChanged(object sender, EventArgs e)
        {
            TestUserFormualSelection();
        }

        private void TB_IPAddress_0_Enter(object sender, System.EventArgs e)
        {
            TB_IPAddress_0.SelectAll();
        }

        private void TB_IPAddress_1_Enter(object sender, System.EventArgs e)
        {
            TB_IPAddress_1.SelectAll();
        }

        private void TB_IPAddress_2_Enter(object sender, System.EventArgs e)
        {
            TB_IPAddress_2.SelectAll();
        }

        private void TB_IPAddress_3_Enter(object sender, System.EventArgs e)
        {
            TB_IPAddress_3.SelectAll();
        }

        private void TestValue(TextBox sObject, String Value, out Int32 iValue)
        {
            try
            {
                iValue = Convert.ToInt32(Value);
            }
            catch
            {
                iValue = 0;
                MessageBox.Show("Value format error", this.Text);
                sObject.Focus();
                throw new System.ApplicationException();
            }
        }

        private void TestValue(TextBox sObject, String Value, Int32 Min, Int32 Max, out Int32 iValue)
        {
            try
            {
                TestValue(sObject, Value, out iValue);

                if ((iValue < Min) || (iValue > Max))
                {
                    MessageBox.Show("Value out of range", this.Text);
                    sObject.Focus();
                    throw new System.ApplicationException();
                }
            }
            catch
            {
                iValue = 0;
                throw new System.ApplicationException();
            }
        }

        private void TestValue(TextBox sObject, String Value, Int32 Min, out Int32 iValue)
        {
            try
            {
                TestValue(sObject, Value, out iValue);

                if (iValue < Min)
                {
                    MessageBox.Show("Value out of range", this.Text);
                    sObject.Focus();
                    throw new System.ApplicationException();
                }
            }
            catch
            {
                iValue = 0;
                throw new System.ApplicationException();
            }
        }

        private void TestUserFormualSelection()
        {
            ulong [] ulAvFreq = {1000, 500, 100, 50, 10, 5, 1};
            ulong ulBaseFreq = ((ulong) CB_SamplingRate.SelectedIndex * 20) + 20;
            ulong ulSelFreq = ulAvFreq[CB_Frequency.SelectedIndex];

            switch (CB_Formula.SelectedIndex)
            {
                /* Sinus */
                case 1:
                    TB_Formula.Text = "ULONG (((sin ((360 / " + (ulBaseFreq * (1000 / ulSelFreq)) + ") * X) + 1) * MAXOUT) / 2)";
                    TB_TimeStep.Text = "1";
                    TB_XStart.Text = "0";
                    TB_XEnd.Text = Convert.ToString((ulBaseFreq * (1000 / ulSelFreq)) - 1);
                    break;

                /* Square */
                case 2:
                    TB_Formula.Text = "BOOL(ULONG(X / (10-5))) * MAXOUT";
                    TB_XStart.Text = "0";
                    TB_XEnd.Text = "9";
                    TB_TimeStep.Text = Convert.ToString((ulBaseFreq * 1000) / ulSelFreq / 10);
                    break;

                /* Triangle */
                case 3:
                    TB_Formula.Text = "(" + ((ulBaseFreq * 1000) / ulSelFreq / 2) + "- abs (X)) * (MAXOUT / " + ((ulBaseFreq * 1000) / ulSelFreq / 2) + ")";
                    TB_TimeStep.Text = "1";
                    TB_XStart.Text = "-" + ((ulBaseFreq * 1000) / ulSelFreq / 2);
                    TB_XEnd.Text = Convert.ToString(((ulBaseFreq * 1000) / ulSelFreq / 2) - 1);
                    break;
            }
        }

		private void B_Connect_Click(object sender, System.EventArgs e)
		{
			UInt64 ulStatus = 0;
			UInt64 ulInfo = 0;
            Int32 iIP0, iIP1, iIP2, iIP3 = 0;


			if ((TB_IPAddress_0.Text.ToString()== "") || (TB_IPAddress_1.Text.ToString()== "") || (TB_IPAddress_2.Text.ToString()== "") || (TB_IPAddress_3.Text.ToString()== ""))
			{
				MessageBox.Show("The IP address you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
			}
			else
			{
                try
                {
                    TestValue(TB_IPAddress_0, TB_IPAddress_0.Text, 0, 255, out iIP0);
                    TestValue(TB_IPAddress_1, TB_IPAddress_1.Text, 0, 255, out iIP1);
                    TestValue(TB_IPAddress_2, TB_IPAddress_2.Text, 0, 255, out iIP2);
                    TestValue(TB_IPAddress_3, TB_IPAddress_3.Text, 0, 255, out iIP3);

                    B_Start.Enabled = false;
                    MX_Common.Url = "http://" + TB_IPAddress_0.Text + "." + TB_IPAddress_1.Text + "." + TB_IPAddress_2.Text + "." + TB_IPAddress_3.Text + ":5555";
					MSXE351x.Url = MX_Common.Url;

					try
					{

						Response = MSXE351x.AnalogOutputGetStatus(0,out ulStatus,out ulInfo);
						if (Response.iReturnValue != 0)
						{
							MessageBox.Show("AnalogOutputGetStatus Error : " + Response.iReturnValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
						}
						else
						{
                            GB_Channel.Enabled = true;
                            GB_Action.Enabled = true;
                            GB_StopState.Enabled = true;
                            GB_SamplingRate.Enabled = true;
                            GB_Formula.Enabled = true;
                            B_Start.Enabled = true;
                            B_Stop.Enabled = false;
                        }
					}
					catch(Exception ex)
					{
						MessageBox.Show("AnalogOutputGetStatus Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
					}
                }
                catch
                {
                }
			}
		}


        private void B_Start_Click(object sender, EventArgs e)
        {
            Int32 iPrescaller = 0;
            Int32 iXStart = 0;
            Int32 iXEnd = 0;
            Int32 iCycles = 0;
            Int32 iTimeStep = 0;
            Int32 iSaveTimeout = 2000;
            int syserno = 0;
            int iReturnValue = 0;
            ulong ulErrorStartPos = 0;
            ulong ulErrorEndPos = 0;
            byte[] bError = new byte[400];
            System.Text.ASCIIEncoding ASCIIEnc = new System.Text.ASCIIEncoding();
            byte[] bFormula = new System.Text.ASCIIEncoding().GetBytes(TB_Formula.Text + "\0");
            Wait WaitFrm = null;

            try
            {
                if (CB_SamplingRate.SelectedIndex > 1)
                {
                    TestValue(TB_Prescaller, TB_Prescaller.Text, 1, out iPrescaller);
                }

                TestValue(TB_XStart, TB_XStart.Text, out iXStart);
                TestValue(TB_XEnd, TB_XEnd.Text, out iXEnd);
                TestValue(TB_Cycles, TB_Cycles.Text, 0, out iCycles);
                TestValue(TB_TimeStep, TB_TimeStep.Text, 1, out iTimeStep);

                try
                {
                    /* Stop the generator */
                    B_Stop_Click(null, null);
                    
                    iReturnValue = MSXE351x.GeneratorInitSamplingRate((ulong)CB_SamplingRate.SelectedIndex, (ulong)iPrescaller, 0, 0, out syserno);

                    if (iReturnValue != 0)
                    {
                        MessageBox.Show("GeneratorInitSamplingRate Error : " + iReturnValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    }
                    else
                    {
                        try
                        {
                            iSaveTimeout = MSXE351x.Timeout;
                            MSXE351x.Timeout = Math.Abs(iXEnd - iXStart) * 10;
                            if (MSXE351x.Timeout <= 2000)
                            {
                                MSXE351x.Timeout = 2000;
                            }
                            else
                            {
                                WaitFrm = new Wait(true);
                            }

                            /* Formula initialisation */
                            Response = MSXE351x.GeneratorInitFormula((ulong)CB_Channel.SelectedIndex, (ulong)CB_OutputType.SelectedIndex, (ulong)CB_Polarity.SelectedIndex,
                                                                     (ulong)iCycles, (ulong)iTimeStep, (ulong)CB_TriggerGate.SelectedIndex, ulTriggerAction,
                                                                     (ulong)(CB_StopMode0.SelectedIndex + (CB_StopMode0.SelectedIndex * 2)),
                                                                     (long)iXStart, (long)iXEnd, bFormula,
                                                                      0, 0, out bError, out ulErrorStartPos, out ulErrorEndPos);

                            if (Response.iReturnValue == -21)
                            {
                                MessageBox.Show("GeneratorInitFormula Error : " + Response.iReturnValue.ToString() + "\n" + new System.Text.ASCIIEncoding().GetString(bError), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            }
                            else if (Response.iReturnValue != 0)
                            {
                                MessageBox.Show("GeneratorInitFormula Error : " + Response.iReturnValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            }
                            else
                            {
                                try
                                {
                                    /* Start the generator */
                                    iReturnValue = MSXE351x.GeneratorStart(1UL << CB_Channel.SelectedIndex, 0, 0, out syserno);
                                    if (iReturnValue != 0)
                                    {
                                        MessageBox.Show("GeneratorStart Error : " + iReturnValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                                    }
                                    else
                                    {
                                        B_Start.Enabled = false;
                                        B_Stop.Enabled = true;
                                        GB_Channel.Enabled = false;
                                        GB_Action.Enabled = false;
                                        GB_StopState.Enabled = false;
                                        GB_SamplingRate.Enabled = false;
                                        GB_Formula.Enabled = false;
                                        B_Start.Enabled = false;
                                        B_Connect.Enabled = false;
                                    }
                                }
                                catch (Exception ex)
                                {
                                    MessageBox.Show("GeneratorStart Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                                }
                            }
                        }
                        catch (Exception ex)
                        {
                            MessageBox.Show("GeneratorInitFormula Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        }

                        if (WaitFrm != null)
                        {
                            WaitFrm.End();
                            WaitFrm.Close();
                        }

                        MSXE351x.Timeout = iSaveTimeout;
                    }
                }
                catch (Exception ex)
                {
                    MessageBox.Show("GeneratorInitSamplingRate Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
            }
            catch
            {
            }
        }

        private void B_Stop_Click(object sender, EventArgs e)
        {
            int syserno = 0;
            int iReturnValue = 0;

            if (sender != null)
            {
                B_Start.Enabled = true;
                B_Stop.Enabled = false;
                GB_Channel.Enabled = true;
                GB_Action.Enabled = true;
                GB_StopState.Enabled = true;
                GB_SamplingRate.Enabled = true;
                GB_Formula.Enabled = true;
                B_Start.Enabled = true;
                B_Connect.Enabled = true;
            }

            try
            {
                /* Start the generator */
                iReturnValue = MSXE351x.GeneratorStop(1UL << CB_Channel.SelectedIndex, 0, 0, out syserno);
                if ((iReturnValue != 0) && (sender != null))
                {
                    MessageBox.Show("GeneratorStart Error : " + iReturnValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
            }
            catch (Exception ex)
            {
                if (sender != null)
                {
                    MessageBox.Show("GeneratorStart Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
            }
        }

        private void F_Main_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (B_Stop.Enabled == true)
            {
                if (MessageBox.Show("Stop the generator?", this.Text, MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
                {
                    B_Stop_Click(null, null);
                }
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            FormulaHelp Help = new FormulaHelp();

            Help.Show();
        }

        private void CB_TriggerAction_SelectedIndexChanged(object sender, EventArgs e)
        {
            switch (CB_TriggerAction.SelectedIndex)
            {
                case 0:
                    ulTriggerAction = 1;
                    break;

                case 1:
                    ulTriggerAction = 2;
                    break;

                case 2:
                    ulTriggerAction = 3;
                    break;

                case 3:
                    ulTriggerAction = 5;
                    break;

                case 4:
                    ulTriggerAction = 6;
                    break;
            }
        }
	}
}
