using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace AnalogOutputFormula
{
    public partial class FormulaHelp : Form
    {
        public FormulaHelp()
        {
            InitializeComponent();
        }

        private void FormulaHelp_Load(object sender, EventArgs e)
        {
            RTB_Help.Rtf =
                            @"{\rtf1\ansi\ansicpg1252\deff0\deflang1031{\fonttbl{\f0\froman\fprq2\fcharset0 Times New Roman;}{\f1\fswiss\fprq2\fcharset0 Arial;}{\f2\fswiss\fcharset0 Arial;}}
{\*\generator Msftedit 5.41.15.1515;}\viewkind4\uc1\pard\lang2057\f0\fs24 The expressions may contain number, constants, defined functions, opening and closing brackets ([()]).\line These elements can be symbols for the four basic arithmetic operations + - * / and the symbol for exponentiation (^ or **) are linked.\line Spaces are ignored in the letter does not distinguish between uppercase and lowercase letters.\line The arithmetic operations are performed in compliance with the priority rules.\par
\par
\pard\fi-360\li720\tx720\f1 -\tab\b\f0 Numbers\b0  can (optionally) a sign, a decimal point and an exponent (possibly with a sign) include (examples: - 2.1 E-5, 5120;. 3125; - 0,001). \par
\pard\fi-360\li720\f1 -\tab\b\f0 Functions\b0  ar applied to an argument to the function name must follow in parentheses. \lang1031\par
\pard\b\par
\pard\fi708\lang2057 Are admissible:\par
\pard\fi-360\li720\tx720\b0\f1 -\tab\f0 The trigonometric functions: sin, cos, tan, cot \par
\pard\fi-360\li720\f1 -\tab\f0 The arc functions asin, acos, atan, acot \par
\f1 -\tab\f0 The hyperbolic functions sinh, cosh, tanh, coth \par
\f1 -\tab\f0 The inverse hyperbolic functions asinh, acosh, atanh, acoth \par
\f1 -\tab\f0 The logarithm function ln (natural logarithm)) and lg (common logarithm) \par
\lang1031\f1 -\tab\f0 The exponential function exp \lang2057\par
\f1 -\tab\f0 The sqrt square root function or sqr \par
\lang1031\f1 -\tab\f0 The absolute value function abs \par
\f1 -\tab\f0 The Signum function sign \lang2057\par
\f1 -\tab\f0 The conversion functions long, ulong, bool, floor, ceil \par
\pard\par
An arithmetic expression is subjected to a syntactic control.\line If he is correct, will try to determine the value of the expression, \line while further inspections are carried out (using a tort case for the standard functions, division by zero, overflow may occur, ...). \line Errors are identified displayed by an indicator (and the area in the string, in which the error was discovered). \par
\par
\b Examples of correct arithmetic expressions: \par
\pard\fi-360\li720\tx720\b0\f1 -\tab\f0 3 * sin (- 210) \par
\pard\fi-360\li720\f1 -\tab\f0 PI / 2 + SQRT [1 + (cos (PI / 4)) ^ (3 / 2)] \par
\pard\par
The constant p (as PI or pi or Pi in the expressions used), and the constant e (base of natural logarithms, in expressions as E or e can be used) are predefined. \par
\b\par
Examples of faulty arithmetic expressions:\b0  \par
\pard\fi-360\li720\tx720\f1 -\tab\f0 3 * - 20 (two consecutive operation symbols) \par
\pard\fi-360\li720\f1 -\tab\f0 27.3 SQRT (argument must be a standard feature in parentheses) \par
\f1 -\tab\f0 LN (COS (PI)) (logarithm with a negative argument) \par
\f1 -\tab\f0 5 / SIN (PI) (division by zero) \par
\f1 -\tab\f0 SINH (1000) (operation leads to overflow) \par
\pard\par
\lang1031\f2\fs20\par
}";
 
        }
    }
}