using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;

namespace AnalogOutputFormula
{
    public partial class Wait : Form
    {
        private bool   boWait     = false;
        private Thread WaitThread = null;
        private Wait   WaitFrm    = null;

        public Wait()
        {
            InitializeComponent();
        }

        public Wait(bool EnableShow)
        {
            InitializeComponent();

            if (EnableShow == true)
            {
                boWait = true;
                WaitThread = new Thread(WaitThreadFct);
                WaitThread.Priority = ThreadPriority.Highest;
                WaitThread.Start();
            }
        }

        private void WaitThreadFct()
        {
            WaitFrm = new Wait(false);
            WaitFrm.Show();

            try
            {
                do
                {

                    WaitFrm.Refresh();
                    System.Threading.Thread.Sleep(100);
                }
                while (boWait == true);

                WaitFrm.End();
                WaitFrm.Close();
            }
            catch
            {
            }
        }

        public void End()
        {
            if (WaitFrm != null)
                boWait = false;
        }
    }
}