using System;
using System.Windows.Forms;

namespace ADDIControls
{
	/// <summary>
	/// Add a propriety Index to the ComboBox Element
	/// </summary>
	public class AddiComboBox : ComboBox
	{
		private int i_Index = 0;

		public AddiComboBox()
		{
		}
		public int Index 
		{
			set {i_Index = value;}
			get {return i_Index;}
	    }
	}
	/// <summary>
	/// Add a propriety Index to the CheckBox Element
	/// </summary>
	public class AddiCheckBox : CheckBox
	{
		private int i_Index = 0;

		public AddiCheckBox()
		{
		}
		public int Index 
		{
			set {i_Index = value;}
			get {return i_Index;}
		}
	}

	/// <summary>
	/// Add a propriety Index to the TextBox Element
	/// </summary>
	public class AddiTextBox : TextBox
	{
		private int i_Index = 0;

		public AddiTextBox()
		{
		}
		public int Index 
		{
			set {i_Index = value;}
			get {return i_Index;}
		}
	}
	

}
